-- MySQL Workbench Synchronization
-- Generated: 2024-03-27 16:22:56
-- Model: nccs
-- Version: R08.08.01
-- Project: iDsteServers
-- Author:

SET @OLD_UNIQUE_CHECKS = @@UNIQUE_CHECKS, UNIQUE_CHECKS = 0;
SET @OLD_FOREIGN_KEY_CHECKS = @@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS = 0;
SET @OLD_SQL_MODE = @@SQL_MODE, SQL_MODE = 'TRADITIONAL,ALLOW_INVALID_DATES';


ALTER TABLE `nccs`.`IPCallRecord`
    MODIFY COLUMN `call_uid` int(11) NOT NULL DEFAULT 0 COMMENT 'IP呼叫发起方用户ID，0-无效值',
    MODIFY COLUMN `pickup_uid` int(11) NOT NULL DEFAULT 0 COMMENT 'IP呼叫接听方用户ID，0-无效值';
ALTER TABLE `nccs`.`IPCallRecordFiles` MODIFY COLUMN `modify_by` int(11) NOT NULL DEFAULT 0 COMMENT '修改人ID';
ALTER TABLE `nccs`.`Asset` MODIFY COLUMN `update_user` int(11) NULL DEFAULT NULL COMMENT '记录更新用户ID';
ALTER TABLE `nccs`.`AssetBatch` MODIFY COLUMN `update_user` int(11) NULL DEFAULT NULL COMMENT '记录更新用户ID';
ALTER TABLE `nccs`.`Theme`
    MODIFY COLUMN `modify_by` int(11) NULL DEFAULT NULL COMMENT '修改人用户ID',
    MODIFY COLUMN `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建/下载时间';
ALTER TABLE `nccs`.`Firmware` MODIFY COLUMN `modify_by` int(11) NULL DEFAULT NULL COMMENT '修改人用户ID';
ALTER TABLE `nccs`.`ResourceFiles`
    MODIFY COLUMN `upload_by` int(11) NULL DEFAULT NULL COMMENT '文件上传人ID',
    MODIFY COLUMN `modify_by` int(11) NULL DEFAULT NULL COMMENT '修改人ID';
ALTER TABLE `nccs`.`TermHistoryConfig`
    MODIFY COLUMN `open` date NULL DEFAULT NULL COMMENT '开学日期',
    MODIFY COLUMN `end` date NULL DEFAULT NULL COMMENT '结束日期';


-- ----------------------------
-- Table structure for DevFaceSDKLicense
-- ----------------------------
DROP TABLE IF EXISTS `nccs`.`DevFaceSDKLicense`;
CREATE TABLE `nccs`.`DevFaceSDKLicense`  (
    `dev_id` varchar(50) NOT NULL COMMENT '设备ID',
    `type` tinyint(2) UNSIGNED NOT NULL COMMENT 'SDK类型，1-百度，2-瑞芯微',
    `license` text NOT NULL COMMENT '授权码',
    `serial_code` varchar(64) NOT NULL DEFAULT '' COMMENT '序列号',
    `auth_state` tinyint(2) UNSIGNED NOT NULL DEFAULT 0 COMMENT '授权状态，0-未授权，1-已授权，2-已过期，3-授权失败',
    `report_state` tinyint(2) UNSIGNED NOT NULL DEFAULT 0 COMMENT '授权结果上报云端状态，0-未上报，1-已上报',
    `reason` varchar(255) NOT NULL DEFAULT '' COMMENT '授权失败原因',
    `update_by` int(11) NULL DEFAULT NULL COMMENT '更新人ID',
    `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',
    `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
    UNIQUE INDEX `uidx_devid_type`(`dev_id`, `type`) USING BTREE COMMENT '设备ID和SDK类型索引'
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_bin COMMENT = '设备人脸SDK授权信息表' ROW_FORMAT = DYNAMIC;


-- ----------------------------
-- Table structure for DevFingerprint
-- ----------------------------
DROP TABLE IF EXISTS `nccs`.`DevFingerprint`;
CREATE TABLE `nccs`.`DevFingerprint`  (
    `dev_id` varchar(50) NOT NULL COMMENT '设备ID',
    `type` tinyint(2) UNSIGNED NOT NULL COMMENT 'SDK类型，1-百度，2-瑞芯微',
    `fingerprint` varchar(255) NOT NULL COMMENT '设备指纹',
    `state` tinyint(2) UNSIGNED NOT NULL DEFAULT 0 COMMENT '指纹上报状态，0-未上报，1-已上报',
    `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',
    `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
    UNIQUE INDEX `uidx_devid_type`(`dev_id`, `type`) USING BTREE COMMENT '设备ID和SDK类型索引'
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_bin COMMENT = '设备指纹表' ROW_FORMAT = DYNAMIC;


SET SQL_MODE = @OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS = @OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS = @OLD_UNIQUE_CHECKS;
