-- MySQL Workbench Synchronization
-- Generated: 2024-03-27 16:22:56
-- Model: nccs
-- Version: R08.08.01
-- Project: iDsteServers
-- Author:

SET @OLD_UNIQUE_CHECKS = @@UNIQUE_CHECKS, UNIQUE_CHECKS = 0;
SET @OLD_FOREIGN_KEY_CHECKS = @@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS = 0;
SET @OLD_SQL_MODE = @@SQL_MODE, SQL_MODE = 'TRADITIONAL,ALLOW_INVALID_DATES';

DROP TABLE IF EXISTS `nccs`.`MicStatus` ;
CREATE TABLE `nccs`.`MicStatus` (
     `id` int NOT NULL AUTO_INCREMENT,
     `dev_id` varchar(255) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL COMMENT '设备ID',
     `space_id` int NOT NULL DEFAULT '0' COMMENT '空间ID',
     `space_location` varchar(255) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL COMMENT '空间位置',
     `mic_id` varchar(255) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL COMMENT '麦克风ID',
     `status` int NOT NULL COMMENT '状态 0：l离线。1：使用中。2：充电中，3：取离，4：对频中',
     `action` int NOT NULL COMMENT '动作',
     `user_id` int NOT NULL DEFAULT '0' COMMENT '操作用户ID',
     `user_name` varchar(255) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT '' COMMENT '用户名称',
     `update_status_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '状态更新时间',
     `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
     PRIMARY KEY (`id`) USING BTREE,
     KEY `index` (`dev_id`,`space_id`,`mic_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8mb3 COMMENT='麦克风 状态更新存储表';

DROP TABLE IF EXISTS `nccs`.`MicUsedTime` ;
CREATE TABLE `nccs`.`MicUsedTime` (
    `id` int NOT NULL AUTO_INCREMENT,
    `dev_id` varchar(255) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL COMMENT '设备ID',
    `space_id` int NOT NULL DEFAULT '0' COMMENT '空间ID',
    `space_location` varchar(255) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL COMMENT '空间位置',
    `mic_id` varchar(255) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL COMMENT '麦克风ID',
    `status` int NOT NULL COMMENT '状态 0：离线。1：使用中。2：充电中，3：取离，4：对频中',
    `user_id` int NOT NULL DEFAULT '0' COMMENT '操作用户ID',
    `user_name` varchar(255) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT '' COMMENT '用户名称',
    `start_time` datetime NOT NULL COMMENT '开始使用时间',
    `end_time` datetime NOT NULL COMMENT '结束使用时长',
    `used_time` int NOT NULL COMMENT '使用时长 单位:s',
    `update_status_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '状态更新时间',
    `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
    PRIMARY KEY (`id`) USING BTREE,
    KEY `index` (`dev_id`,`space_id`,`mic_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8mb3 COMMENT='麦克风使用时长记录';

-- 针对测试环境大量虚拟设备使用。会导致麦克风ID中存在“：” 冒号 在转10进制会出现问题。特殊处理、直接删除掉 包含冒号的麦克风ID
DELETE FROM MicPhoneList  WHERE INSTR(id,':')>0;

-- 删除 59/58 中控的对应的麦克风转换后有重复麦克风ID数据。保留（最新修改过麦克风数据）
DELETE m1 FROM MicPhoneList m1  INNER JOIN (SELECT  (CASE WHEN LEFT(m.last_dev_id,2) IN ('59','58') THEN CONV(m.id, 16, 10) ELSE m.id END) as newID,MAX(m.update_time)  as update_time FROM MicPhoneList m GROUP BY newID HAVING COUNT(*)>1)  as m2 on (CASE WHEN LEFT(m1.last_dev_id,2) IN ('59','58') THEN CONV(m1.id, 16, 10) ELSE m1.id END)=m2.newID and m1.update_time<m2.update_time ;

-- 修改麦克风ID
UPDATE MicPhoneList SET  id=CONV(id, 16, 10) WHERE  LEFT(last_dev_id,2) IN ('59','58');

SET SQL_MODE = @OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS = @OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS = @OLD_UNIQUE_CHECKS;
