-- MySQL Workbench Synchronization
-- Generated: 2018-12-28 12:01
-- Model: nccs
-- Version: D06.07.01
-- Project: idste-server
-- Author: marh(marh@idste.cn)

SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL,ALLOW_INVALID_DATES';
-- D06.07.01
CREATE TABLE `nccs`.`NotificationMsg` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `uid` INT NOT NULL COMMENT '用户ID',
  `type` VARCHAR(32) NOT NULL COMMENT '事件类型',
  `time` DATETIME NULL COMMENT '消息推送的时间',
  `ipaddress` VARCHAR(45) NULL COMMENT '消息推送的ip地址',
  `description` VARCHAR(4096) NOT NULL COMMENT '推送的具体消息内容.',
  `update_at` DATETIME NULL,
  `handle_uid` INT(11) NULL,
  `status` ENUM('PENDING', 'RESOLVED', 'REJECTED') NOT NULL DEFAULT 'PENDING',
  PRIMARY KEY (`id`),
  UNIQUE INDEX `id_UNIQUE` (`id` ASC))
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8mb4;

-- D06.07.02
ALTER TABLE `nccs`.`SectionTable`
    CHANGE COLUMN `name` `name` VARCHAR(32) NOT NULL DEFAULT '0' COMMENT '仅填写数字，表示第几节课。为保证兼容，未做类型变更' ,
    CHANGE COLUMN `start` `start` TIME NOT NULL DEFAULT '00:00:00' ,
    CHANGE COLUMN `end` `end` TIME NOT NULL DEFAULT '23:59:59' ,
    ADD COLUMN `alias` VARCHAR(32) NOT NULL COMMENT '节次别名，如第一节' AFTER `name`,
    ADD PRIMARY KEY (`name`),
    ADD UNIQUE INDEX `SectionTableUnique` (`zone` ASC, `name` ASC),
    ADD INDEX `SectionTableIndex` (`name` ASC, `zone` ASC);

CREATE TABLE IF NOT EXISTS `nccs`.`TimetableV1` (
    `ID` INT(11) NOT NULL AUTO_INCREMENT,
    `Dev_Name` VARCHAR(50) NOT NULL,
    `User_Sn` VARCHAR(20) NOT NULL,
    `Zone` VARCHAR(32) NOT NULL DEFAULT '',
    `CourseName` VARCHAR(64) NOT NULL DEFAULT '',
    `TermName` VARCHAR(32) NOT NULL DEFAULT '',
    `SectionStart` INT(11) NOT NULL DEFAULT '0',
    `SectionEnd` INT(11) NOT NULL DEFAULT '0',
    `WeekStart` INT(11) NOT NULL DEFAULT '1',
    `WeekEnd` INT(11) NOT NULL DEFAULT '9999',
    `WeekDay` INT(11) NOT NULL DEFAULT '6',
    `WeekType` ENUM('single', 'double', 'all') NOT NULL DEFAULT 'all',
    `Active` ENUM('yes', 'no') NOT NULL DEFAULT 'yes' COMMENT '是否活动，活动状态的课表会用于设备控制',
    PRIMARY KEY (`ID`))
    ENGINE = InnoDB
    DEFAULT CHARACTER SET = utf8;

CREATE TABLE IF NOT EXISTS `nccs`.`Scene` (
  `id` INT NOT NULL,
  `name` VARCHAR(45) NOT NULL DEFAULT '' COMMENT '名称',
  `icon` VARCHAR(45) NOT NULL DEFAULT '' COMMENT '图标',
  `control_list` VARCHAR(2048) NOT NULL DEFAULT '{}' COMMENT '操作清单',
  `product_match_preg` VARCHAR(128) NOT NULL DEFAULT '' COMMENT '产品匹配列表',
  PRIMARY KEY (`id`))
    COMMENT = '设备场景表';

-- D06.07.03
CREATE TABLE IF NOT EXISTS `nccs`.`DeviceExt` (
  `DevID` VARCHAR(50) NOT NULL,
  `RecorderUrl` VARCHAR(2048) NULL DEFAULT '{}',
  PRIMARY KEY (`DevID`),
  CONSTRAINT `DevID`
      FOREIGN KEY (`DevID`)
          REFERENCES `nccs`.`DeviceList` (`DevID`)
          ON DELETE NO ACTION
          ON UPDATE NO ACTION)
    COMMENT = '设备扩展信息表';

ALTER TABLE `nccs`.`TimetableV1`
    CHANGE COLUMN `User_Sn` `User_Flag` VARCHAR(20) NOT NULL DEFAULT '' ,
    ADD COLUMN `User_Name` VARCHAR(32) NOT NULL DEFAULT ''  COMMENT '"tmp_phone"临时课需要填写用户姓名' AFTER `User_Flag`,
    ADD COLUMN `Type` ENUM('normal', 'tmp_usersn', 'tmp_phone') NOT NULL DEFAULT 'normal' COMMENT 'normal: 正式课\ntmp_usersn:用户工号临时课\ntmp_phone:手机号临时课' AFTER `Active`,
    ADD INDEX `TimetableV1_idx2` (`Dev_Name` ASC),
    ADD INDEX `TimetableV1_idx1` (`User_Flag` ASC);

-- D06.07.05
ALTER TABLE `nccs`.`Scene`
    CHANGE COLUMN `id` `id` INT(11) NOT NULL AUTO_INCREMENT ;

-- D06.07.08
ALTER TABLE `nccs`.`DeviceStatus`
    ADD COLUMN `Scene` INT(10) UNSIGNED NULL DEFAULT NULL AFTER `Recorder`;

TRUNCATE TABLE `nccs`.`DeviceExt`;

ALTER TABLE `nccs`.`DeviceExt`
    CHANGE COLUMN `RecorderUrl` `Name` VARCHAR(45) NOT NULL DEFAULT '{}' ,
    CHANGE COLUMN `SceneConfig` `Config` VARCHAR(2048) NOT NULL DEFAULT '{}' ,
    ADD UNIQUE INDEX `DeviceExt_uni` (`DevID` ASC, `Name` ASC),
    ADD INDEX `DeviceExt_idx` (`DevID` ASC, `Name` ASC),
    DROP PRIMARY KEY;

-- D06.07.12
ALTER TABLE `nccs`.`DeviceExt`
    DROP FOREIGN KEY `DevID`;

ALTER TABLE `nccs`.`BaseInfo`
    CHANGE COLUMN `Description` `Description` VARCHAR(1024) NULL DEFAULT NULL ;

ALTER TABLE `nccs`.`DeviceExt`
    CHANGE COLUMN `Name` `Name` VARCHAR(45) NOT NULL ;

CREATE TABLE IF NOT EXISTS `nccs`.`DeviceStatusExt` (
    `ID` VARCHAR(50) NOT NULL COMMENT 'extended device id',
    `Name` VARCHAR(50) NOT NULL COMMENT 'status name',
    `MainID` VARCHAR(50) NOT NULL COMMENT 'main device id',
    `Status` VARCHAR(1024) NOT NULL DEFAULT '{}' COMMENT 'extened device\'s status, json format',
    `UpdateAt` DATETIME NOT NULL,
    UNIQUE INDEX `DeviceStatusExtUni` (`MainID` ASC, `Name` ASC),
    INDEX `DeviceStatusExtIdx` (`MainID` ASC, `ID` ASC))
    ENGINE = MEMORY
    DEFAULT CHARACTER SET = utf8;

ALTER TABLE `nccs`.`DeviceExt`
    ADD CONSTRAINT `DevID`
        FOREIGN KEY (`DevID`)
            REFERENCES `nccs`.`DeviceList` (`DevID`)
            ON DELETE CASCADE
            ON UPDATE CASCADE;

-- D06.07.13
ALTER TABLE `nccs`.`DeviceDesiredStaus`
    ADD COLUMN `PowerAction` TINYINT(4) NULL DEFAULT NULL AFTER `SysEnabled`,
    ADD COLUMN `RfCtrlAction` BINARY(16) NULL DEFAULT NULL AFTER `RfDevCtrl`;

-- D06.07.15
ALTER TABLE `nccs`.`DeviceStatus`
    ADD COLUMN `Protocol` INT(10) NULL DEFAULT '1' AFTER `Scene`;

-- D06.07.19
ALTER TABLE `nccs`.`DeviceDesiredStaus`
    DROP COLUMN `ModePriority`,
    DROP COLUMN `BrdMode`;

-- D06.07.20
ALTER TABLE `nccs`.`BroadcastMode`
    ADD COLUMN `StartEntryID` INT(11) NOT NULL DEFAULT '0' AFTER `Active`,
    ADD COLUMN `StopEntryID` INT(11) NOT NULL DEFAULT '0' AFTER `StartEntryID`;

ALTER TABLE `nccs`.`PlaySessionTime`
    ADD COLUMN `EntryID` INT(11) NOT NULL DEFAULT '0' AFTER `Length`;

ALTER TABLE `nccs`.`DeviceList`
    ADD COLUMN `Ip` varchar(50) DEFAULT NULL,
    ADD COLUMN `Proto` int(10) DEFAULT '1',
    ADD COLUMN `DevType` int(11) NOT NULL DEFAULT '0';


CREATE TABLE IF NOT EXISTS `nccs`.`DeviceCtrlList` (
    `id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
    `DevID` VARCHAR(50) NOT NULL,
    `SubID` INT(11) NOT NULL,
    `State` INT(11) NULL DEFAULT NULL,
    PRIMARY KEY (`id`),
    UNIQUE INDEX `index` USING BTREE (`DevID` ASC, `SubID` ASC))
    ENGINE = InnoDB
    DEFAULT CHARACTER SET = utf8;


CREATE TABLE IF NOT EXISTS `nccs`.`SessionCtrlList` (
    `id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
    `SessionID` SMALLINT(6) NOT NULL,
    `SubID` INT(11) NOT NULL,
    `State` INT(11) NULL DEFAULT NULL,
    `Action` INT(11) NULL DEFAULT NULL,
    PRIMARY KEY (`id`),
    UNIQUE INDEX `SesSubID_UNIQUE` USING BTREE (`SessionID` ASC, `SubID` ASC),
    INDEX `SessionID` USING BTREE (`SessionID` ASC))
    ENGINE = InnoDB
    DEFAULT CHARACTER SET = utf8;

-- D06.07.34
ALTER TABLE `nccs`.`PlayingSessions`
    ADD COLUMN `PlayBeginTime` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP AFTER `StreamType`;

-- D06.07.39
ALTER TABLE `nccs`.`BrdModeMember`
    DROP FOREIGN KEY `ModeDeviceID`,
    DROP FOREIGN KEY `BrdModeID`;

ALTER TABLE `nccs`.`DevCtrlSchedule`
    DROP FOREIGN KEY `DevCtrlDevId`;

ALTER TABLE `nccs`.`DisableDevSession`
    DROP FOREIGN KEY `DisabledScheDevice`,
    DROP FOREIGN KEY `DisDevShedule`;

ALTER TABLE `nccs`.`MediaFiles`
    DROP FOREIGN KEY `MediaUser`;

ALTER TABLE `nccs`.`MsgTaskDev`
    DROP FOREIGN KEY `msgtaskdev`,
    DROP FOREIGN KEY `msgtask`;

ALTER TABLE `nccs`.`PlayListFiles`
    DROP FOREIGN KEY `SessionID`,
    DROP FOREIGN KEY `FileID`;

ALTER TABLE `nccs`.`PlaySessionTime`
    DROP FOREIGN KEY `Schsessionid`;

ALTER TABLE `nccs`.`PlaySessions`
    DROP FOREIGN KEY `TaskTemplate`,
    DROP FOREIGN KEY `SessionUser`,
    DROP FOREIGN KEY `SessionParent`,
    DROP FOREIGN KEY `SessionMode`,
    DROP FOREIGN KEY `Players`;

ALTER TABLE `nccs`.`Users`
    DROP FOREIGN KEY `UsbKey`;

ALTER TABLE `nccs`.`SectionTable`
    CHANGE COLUMN `name` `name` VARCHAR(32) NOT NULL DEFAULT '0' COMMENT '仅填写数字，表示第几节课。\n为保证兼容，未做类型变更' ;

-- D06.07.54
ALTER TABLE `nccs`.`DeviceStatistic`
    ADD INDEX `StatisticDay` USING BTREE (`StatisticDay` ASC);

-- D06.07.55
ALTER TABLE `nccs`.`DeviceLog`
    ADD INDEX `endTime_idx` USING BTREE (`EndTime` ASC),
    ADD INDEX `dateTime_idx` USING BTREE (`DateTime` ASC);


SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;
