-- MySQL Workbench Synchronization
-- Generated: 2021-3-1 09:39
-- Model: New Model
-- Version: D07.01.02
-- Project: nccs`
-- Author: ww

SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL,ALLOW_INVALID_DATES';

-- D07.01.02
ALTER TABLE `nccs`.`Users` ADD COLUMN `IsSuper` tinyint(1) NOT NULL DEFAULT 0 COMMENT '是否是超级管理员' AFTER `Priority`;

ALTER TABLE `nccs`.`Users` ADD COLUMN `PrivilegeList` varchar(4096) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '用户权限列表' AFTER `privilege`;

-- 解决6.8 中 TaskTemplate 表 中本身就存在 Enabled=1 的数据
UPDATE nccs.TaskTemplate SET `Enabled`=0 WHERE `Enabled`=1;


-- 这一条语句会导致新插入的内容的IDTaskTemplate自增，需要在update一次
-- 这个逻辑适用于没有id=0的情况
-- insert into `nccs`.TaskTemplate  (select `InfoValue`,"",1 from `nccs`.`BaseInfo` where `InfoValue` != -1 and `InfoMationID` = 257) on duplicate key update `Enabled`=1;
-- update `nccs`.TaskTemplate set `idTaskTemplate` = (select `InfoValue` from `nccs`.`BaseInfo` where `InfoValue` != -1 and `InfoMationID` = 257) where Enabled=1;

update `nccs`.TaskTemplate set `Enabled` = 1 where `idTaskTemplate` in (select `InfoValue` from `nccs`.`BaseInfo` where `InfoValue` != -1 and `InfoMationID` = 257);
DELETE from `nccs`.`BaseInfo` where `InfomationID` = 257;

-- D07.01.07
CREATE TABLE IF NOT EXISTS `nccs`.`DeviceAuthSupplyLog` (
    `Id` int(11) NOT NULL AUTO_INCREMENT,
    `Type` varchar(255) NOT NULL DEFAULT '' COMMENT '认证类型',
    `Supply` varchar(255) NOT NULL DEFAULT '' COMMENT '供应商',
    `Url` varchar(1024) NOT NULL DEFAULT '' COMMENT '请求URL',
    `ReqInfo` varchar(4096) NOT NULL DEFAULT '' COMMENT '请求数据',
    `ResInfo` varchar(4096) NOT NULL DEFAULT '' COMMENT '响应数据',
    `Result` tinyint(4) NOT NULL DEFAULT '0' COMMENT '请求结果 0-失败 1-成功',
    `ErrorType` tinyint(4) NOT NULL DEFAULT '0' COMMENT '错误类型 0-无错误 1-系统未配置好 2-供应商返回错误 3-人员信息未找到 4-网络出现问题',
    `Error` varchar(4096) NOT NULL DEFAULT '' COMMENT '错误信息',
    `StartTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '开始时间',
    `EndTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '结束时间',
    `UseTime` int(11) NOT NULL DEFAULT '0' COMMENT '耗时（毫秒数）',
    `Sync` tinyint(4) NOT NULL DEFAULT '0' COMMENT '是否同步 0-未同步 1-已同步',
    `AddTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '添加时间',
                                                            PRIMARY KEY (`Id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COMMENT='设备认证供应商日志';


CREATE TABLE IF NOT EXISTS `nccs`.`DeviceScenes`  (
  `DeviceSceneID` int(11) NOT NULL AUTO_INCREMENT,
  `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
  `SceneID` int(11) NOT NULL,
  `SceneName` varchar(96) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '场景名称不能超过32个汉字',
  `SceneCtrlList` varchar(4096) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '场景控制列表，为json字符串',
  PRIMARY KEY (`DeviceSceneID`) USING BTREE,
  UNIQUE INDEX `device_scene`(`DeviceID`, `SceneID`) USING BTREE COMMENT '一个设备不能有两个相同id的场景'
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;


-- D07.01.08
ALTER TABLE `nccs`.`DeviceList`
    ADD COLUMN `DoubleClass` tinyint(4) NOT NULL DEFAULT '0' COMMENT '是否支持双师课堂 0-不支持 1-支持' after `DevType`;

CREATE TABLE IF NOT EXISTS `nccs`.`DoubleClass` (
        `ClassId` int(11) NOT NULL AUTO_INCREMENT COMMENT '课堂ID',
        `ClassName` varchar(255) NOT NULL DEFAULT '' COMMENT '课堂名称',
        `ExecTime` enum('WeekLoop','FixedTime') NOT NULL DEFAULT 'FixedTime' COMMENT 'WeekLoop - 按周循环  FixedTime - 固定时间',
        `FixStime` bigint(20) NOT NULL DEFAULT '0' COMMENT '固定时间 - 开始时间',
        `FixEtime` bigint(20) NOT NULL DEFAULT '0' COMMENT '固定时间 - 结束时间',
        `WeekStime` time NOT NULL COMMENT '按周循环 - 开始时间',
        `WeekEtime` time NOT NULL COMMENT '按周循环 - 结束时间',
        `WeekDays` varchar(255) NOT NULL DEFAULT '' COMMENT '0-6 对应 星期一 到 星期天 (英文逗号分隔,结束都加英文逗号)',
        `Valid` tinyint(4) NOT NULL DEFAULT '1' COMMENT '是否有效 1-有效 0-无效',
        `ConfigMd5` varchar(255) NOT NULL DEFAULT '' COMMENT '配置MD5',
        `AddTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '添加时间',
        `ModTIme` bigint(20) NOT NULL DEFAULT '0' COMMENT '修改时间',
        `NextStime` bigint(20) NOT NULL DEFAULT '0' COMMENT '下次开始时间',
        `NextEtime` bigint(20) NOT NULL DEFAULT '0' COMMENT '下次结束时间',
        `CourseId` int(11) NOT NULL DEFAULT '0' COMMENT '双师课堂课程ID',
        `CourseTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '上课时间',
        `CourseStatus` enum('free','active','stop','fault') NOT NULL DEFAULT 'free' COMMENT '上课状态（无课-free  上课-active  停止-stop  故障-fault）',
        `CourseFault` varchar(1024) NOT NULL DEFAULT '' COMMENT '课程故障原因',
        PRIMARY KEY (`ClassId`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COMMENT='双师课堂列表';

CREATE TABLE IF NOT EXISTS `DoubleClassDevice` (
       `Id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'ID',
       `ClassId` int(11) NOT NULL DEFAULT '0' COMMENT '双师课堂ID',
       `DevId` varchar(50) NOT NULL DEFAULT '' COMMENT '设备ID',
       `ClassType` enum('lead','follow') NOT NULL DEFAULT 'lead' COMMENT '教室类型（lead - 主讲教室  follow - 辅讲教室）',
       `DeviceType` enum('main','slave') NOT NULL DEFAULT 'main' COMMENT '设备类型（main - 主控设备  slave - 从设备）',
       `Ip` varchar(255) NOT NULL DEFAULT '' COMMENT '设备IP地址',
       `CmdConfig` tinyint(4) NOT NULL DEFAULT '0' COMMENT '0-未发送配置命令 1-已发送配置命令',
       `CmdConfigTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '发送配置命令时间',
       PRIMARY KEY (`Id`),
       UNIQUE KEY `ClassDev` (`ClassId`,`DevId`),
       KEY `ClassId` (`ClassId`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COMMENT='双师课堂设备';

CREATE TABLE IF NOT EXISTS `nccs`.`DoubleClassCourse` (
      `CourseId` int(11) NOT NULL AUTO_INCREMENT COMMENT '课程ID',
      `ClassId` int(11) NOT NULL DEFAULT '0' COMMENT '双师课堂ID',
      `ClassName` varchar(255) NOT NULL DEFAULT '' COMMENT '课堂名称',
      `ExecTime` enum('WeekLoop','FixedTime') NOT NULL DEFAULT 'FixedTime' COMMENT '执行时间',
      `FixStime` bigint(20) NOT NULL DEFAULT '0' COMMENT '固定时间-开始时间',
      `FixEtime` bigint(20) NOT NULL DEFAULT '0' COMMENT '固定时间 - 结束时间',
      `WeekStime` time NOT NULL COMMENT '按周循环-开始时间',
      `WeekEtime` time NOT NULL COMMENT '按周循环-结束时间',
      `WeekDays` varchar(255) NOT NULL DEFAULT '' COMMENT '0-6 对应 星期一 到 星期天 (英文逗号分隔,结束加英文逗号)',
      `CourseStime` bigint(20) NOT NULL DEFAULT '0' COMMENT '课程开始时间',
      `CourseEtime` bigint(20) NOT NULL DEFAULT '0' COMMENT '课程结束时间',
      `AddTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '添加时间',
      `CmdStartNums` int(11) NOT NULL DEFAULT '0' COMMENT '开始命令发送次数',
      `CmdStartTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '开始命令发送时间',
      `CourseStarted` tinyint(4) NOT NULL DEFAULT '0' COMMENT '是否上报已启动 0-未启动 1-已启动',
      `CmdEndNums` int(11) NOT NULL DEFAULT '0' COMMENT '结束命令发送次数',
      `CmdEndTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '结束命令发送时间',
      `CourseEnded` tinyint(4) NOT NULL DEFAULT '0' COMMENT '是否上报已结束 0-未上报 1-已上报',
      `CourseStatus` enum('creat','active','stop','fault','end') NOT NULL DEFAULT 'creat' COMMENT '课程状态（生成-creat  上课-active  停止-stop  故障-fault 结束-end）',
      `CourseFault` varchar(1024) NOT NULL DEFAULT '' COMMENT '故障原因',
      `ModTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '最后修改时间',
      PRIMARY KEY (`CourseId`),
      KEY `ClassId` (`ClassId`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COMMENT='双师课堂课程（定时生成）';

CREATE TABLE IF NOT EXISTS `nccs`.`DoubleClassCourseDevice` (
    `Id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'ID',
    `ClassId` int(11) NOT NULL DEFAULT '0' COMMENT '双师课堂ID',
    `CourseId` int(11) NOT NULL DEFAULT '0' COMMENT '双师课堂课程ID',
    `DevId` varchar(255) NOT NULL DEFAULT '' COMMENT '设备ID',
    `ClassType` enum('lead','follow') NOT NULL DEFAULT 'lead' COMMENT '教室类型（lead - 主讲教室  follow - 辅讲教室）',
    `DeviceType` enum('main','slave') NOT NULL DEFAULT 'main' COMMENT '设备类型（main - 主控设备  slave - 从设备）',
    `CmdStart` tinyint(4) NOT NULL DEFAULT '0' COMMENT '是否发送启动命令 0-未发送 1-已发送',
    `CmdStartTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '发送启动命令时间',
    `CmdStartNums` int(11) NOT NULL DEFAULT '0' COMMENT '发送启动命令次数',
    `CmdStartReport` tinyint(4) NOT NULL DEFAULT '0' COMMENT '是否上报处于双师课堂 0-未处于 1-已处于',
    `CmdStartReportTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '设备上报处于双师课堂时间',
    `CmdEnd` tinyint(4) NOT NULL DEFAULT '0' COMMENT '是否发送停止命令 0-未发送 1-已发送',
    `CmdEndTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '发送停止命令时间',
    `CmdEndNums` int(11) NOT NULL DEFAULT '0' COMMENT '发送停止命令次数',
    `CmdEndReport` tinyint(4) NOT NULL DEFAULT '0' COMMENT '是否上报不处于双师课堂 0-未上报 1-已上报',
    `CmdEndReportTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '设备上报不处于双师课堂时间',
    PRIMARY KEY (`Id`),
    UNIQUE KEY `CourseDev` (`CourseId`,`DevId`),
    KEY `ClassId` (`ClassId`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COMMENT='双师课堂课程设备';

CREATE TABLE IF NOT EXISTS `nccs`.`DoubleClassLog` (
   `Id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT 'ID',
   `ClassId` int(11) NOT NULL DEFAULT '0' COMMENT '双师课堂ID',
   `CourseId` int(11) NOT NULL DEFAULT '0' COMMENT '双师课堂课程ID',
   `DevId` varchar(255) NOT NULL DEFAULT '' COMMENT '设备ID',
   `Title` varchar(255) NOT NULL DEFAULT '' COMMENT '事件标题',
   `Detail` varchar(4096) NOT NULL DEFAULT '' COMMENT '详细数据',
   `AddTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '添加时间',
   PRIMARY KEY (`Id`),
   KEY `CourseId` (`CourseId`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COMMENT='双师课堂运行详细日志';

CREATE TABLE IF NOT EXISTS `nccs`.`DevStartingPic`  (
    `Type` tinyint(4) NOT NULL COMMENT '图片类型，0---TM03背景图，1---TM03前景图，2---面板开机图片',
    `User` int(11) NULL DEFAULT NULL COMMENT '上传用户ID',
    `Path` varchar(255) NOT NULL COMMENT '文件路径',
    `SyncVal` int(11) NOT NULL DEFAULT 1 COMMENT '整数同步字',
    PRIMARY KEY (`Type`) USING BTREE
)
    ENGINE = InnoDB
    CHARACTER SET = utf8;

-- D07.01.12
INSERT INTO BaseInfo(InfomationID, Description, InfoValue) VALUES ('625', 'double class log record off', 1) on duplicate key update InfomationID=values(InfomationID);

-- D07.01.15
UPDATE `nccs`.`DeviceList` SET DevType=0;

ALTER TABLE `nccs`.`Players`
    ADD COLUMN `RtmpURL` varchar(255) NOT NULL DEFAULT '' AFTER `Remark`;

-- 更新任务中流媒体文件播放时长为0（原来设置了默认10秒）
UPDATE `nccs`.`PlayListFiles` SET `Duration` = 0 WHERE `FileID` IN (SELECT `MediaID` FROM `nccs`.`MediaFiles` WHERE `FileFmt` = -1) AND `Duration` = 10;

CREATE TABLE IF NOT EXISTS `nccs`.`PcCallDirectories`  (
       `DirectoryID` int(10) NOT NULL AUTO_INCREMENT,
       `Name` varchar(63) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
       `SessionID` int(10) NOT NULL,
       PRIMARY KEY (`DirectoryID`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;


CREATE TABLE IF NOT EXISTS `nccs`.`PcCallBindFiles`  (
     `BindID` int(10) NOT NULL AUTO_INCREMENT,
     `FileID` int(10) NOT NULL,
     `SessionID` int(10) NOT NULL,
     `Parent` int(10) NOT NULL,
     `OrderIndex` int(10) NOT NULL COMMENT '播放顺序',
     PRIMARY KEY (`BindID`) USING BTREE,
     UNIQUE INDEX `parent_file`(`FileID`, `Parent`) USING BTREE COMMENT '一个目录下面不出现两个一样的文件'
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

-- D07.01.16
ALTER TABLE `nccs`.`PcCallDirectories` ADD COLUMN `IsDefault` tinyint(1) NOT NULL AFTER `SessionID`;
ALTER TABLE `nccs`.`DoubleClassCourse` ADD COLUMN `ManualStopTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '手动停止时间' AFTER `CourseEnded`;

-- D07.01.17
-- 更新任务中流媒体文件播放时长为0（原来设置了默认10秒）
UPDATE `nccs`.`MediaFiles` SET `TotalTime` = 0 WHERE `FileFmt` = -1 AND `TotalTime` = 10;

-- D07.01.19
ALTER TABLE `nccs`.`TaskTemplate` MODIFY COLUMN `TemplateName` varchar(50);


SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;
