-- MySQL Workbench Synchronization
-- Generated: 2021-8-4 16:53
-- Model: New Model
-- Version: D07.03.01
-- Project: nccs`
-- Author: ww
SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL,ALLOW_INVALID_DATES';
-- D07.03.01
CREATE TABLE IF NOT EXISTS `nccs`.`EnvironmentalParameters`  (
  `ID` int(10) NOT NULL AUTO_INCREMENT,
  `ProtocolFieldName` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '参数在协议中对应的字段',
  `Name` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '参数名称',
  `Unit` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '单位',
  `ExactValue` float(20, 9) UNSIGNED NOT NULL DEFAULT 1.000000000 COMMENT '精确度',
  PRIMARY KEY (`ID`) USING BTREE,
  UNIQUE INDEX `protocolFieldName`(`ProtocolFieldName`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;


-- SystemLog
ALTER TABLE `SystemLog` DROP PRIMARY KEY, ADD PRIMARY KEY (`id`, `at`);

-- DeviceLog
ALTER TABLE `DeviceLog` ADD COLUMN `DeviceName` varchar(255) NOT NULL DEFAULT '' COMMENT '设备位置名称' AFTER `DeviceID`;
ALTER TABLE `DeviceLog` ADD COLUMN `UserName` varchar(255) NOT NULL DEFAULT '' COMMENT '用户姓名' AFTER `CtrlUser`;
ALTER TABLE `DeviceLog` MODIFY COLUMN `DateTime`  datetime NOT NULL AFTER `DeviceName`, DROP PRIMARY KEY, ADD PRIMARY KEY (`DevLogID`, `DateTime`);

-- DeviceLog.UserName init value
UPDATE DeviceLog, Users SET DeviceLog.UserName = Users.User_Desc WHERE DeviceLog.CtrlUser IS NOT NULL AND DeviceLog.CtrlUser = Users.User_ID AND DeviceLog.UserName = '' AND Users.User_Desc IS NOT NULL;
UPDATE DeviceLog, Users SET DeviceLog.UserName = Users.User_Name WHERE DeviceLog.CtrlUser IS NOT NULL AND DeviceLog.CtrlUser = Users.User_ID AND DeviceLog.UserName = '' AND Users.User_Name IS NOT NULL;
UPDATE DeviceLog, Users SET DeviceLog.UserName = Users.User_Sn WHERE DeviceLog.CtrlUser IS NOT NULL AND DeviceLog.CtrlUser = Users.User_ID AND DeviceLog.UserName = '' AND Users.User_Sn IS NOT NULL;
UPDATE DeviceLog, Users SET DeviceLog.UserName = Users.Phone WHERE DeviceLog.CtrlUser IS NOT NULL AND DeviceLog.CtrlUser = Users.User_ID AND DeviceLog.UserName = '' AND Users.Phone IS NOT NULL;
-- DeviceLog.DeviceName init value
UPDATE DeviceLog, DeviceList SET DeviceLog.DeviceName = CONVERT(convert(DeviceList.Dev_Description USING gbk), CHAR(255)) WHERE DeviceLog.DeviceID IS NOT NULL AND DeviceLog.DeviceID = DeviceList.DevID AND DeviceLog.DeviceName = '' AND DeviceList.Dev_Description IS NOT NULL;
UPDATE DeviceLog, DeviceList SET DeviceLog.DeviceName = DeviceList.Dev_Name WHERE DeviceLog.DeviceID IS NOT NULL AND DeviceLog.DeviceID = DeviceList.DevID AND DeviceLog.DeviceName = '' AND DeviceList.Dev_Name IS NOT NULL;
UPDATE DeviceLog SET DeviceName = DeviceID WHERE DeviceName = '';

CREATE TABLE IF NOT EXISTS `nccs`.`EnvControlDevices`  (
  `ID` int(10) NOT NULL AUTO_INCREMENT,
  `EnvCtrlInfoID` int(10) NOT NULL,
  `DeviceID` varchar(10) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  PRIMARY KEY (`ID`) USING BTREE,
  UNIQUE INDEX `ctrlID_devID`(`EnvCtrlInfoID`, `DeviceID`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;


CREATE TABLE IF NOT EXISTS `nccs`.`EnvControlInfo`  (
  `ID` int(10) NOT NULL AUTO_INCREMENT,
  `Type` int(10) NOT NULL COMMENT '策略类型。1：环境策略',
  `Name` varchar(1024) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '策略的名称',
  `Conditions` varchar(4096) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '{}' COMMENT '策略条件。json格式',
  `Duration` int(10) NOT NULL COMMENT '满足条件以后需要持续该时间长度才执行任务',
  `Operation` varchar(4096) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL  DEFAULT '{}' COMMENT '该策略需要执行的操作。json格式',
  `Weekday` int(10) NOT NULL COMMENT '表示周几。bit1-bit6表示周一到周六，bit0表示周天',
  `EntryTimeType` int(10) NOT NULL COMMENT '生效时间类型 0：表示每天中哪个时间范围执行该策略 1：表示每天中哪个时间点执行该策略',
  `StartTime` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '与EndTime一起作用，比如：08:00:00 EntryTimeType = 0时有效',
  `EndTime` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '与StartTime一起作用，比如：12:00:00 EntryTimeType = 0时有效',
  `TimeSpot` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '比如：09:00:00 EntryTimeType = 2时有效',
  PRIMARY KEY (`ID`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;


-- D07.03.03
ALTER TABLE `nccs`.`EnvironmentalParameters` MODIFY COLUMN `ExactValue` float(8, 3) UNSIGNED NOT NULL DEFAULT 1.000 COMMENT '精确度' AFTER `Unit`;

-- D07.03.04
UPDATE `nccs`.`TaskTemplate` SET `TemplateName`='' WHERE `TemplateName` IS NULL;
ALTER TABLE `nccs`.`TaskTemplate` MODIFY COLUMN `TemplateName` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' AFTER `idTaskTemplate`;
ALTER TABLE `nccs`.`TaskTemplate` MODIFY COLUMN `Enabled` tinyint(4) NOT NULL DEFAULT 0 AFTER `TemplateName`;

CREATE TABLE IF NOT EXISTS   `nccs`.`RfConfig`(
      `PwrID` tinyint(4) NOT NULL,
      `Name` varchar(45) DEFAULT NULL COMMENT '物联名称',
      `ChildType` int(11) NOT NULL  COMMENT '物联二级类型',
      `DevID` varchar(50) NOT NULL DEFAULT '0' COMMENT '设备ID',
      UNIQUE KEY `uniqueIndex` (`PwrID`,`DevID`) USING BTREE,
      KEY `devIdIndex` (`DevID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物联配置表基于设备';

CREATE TABLE IF NOT EXISTS  `nccs`.`SessionCtrlListType` (
     `id` INT ( 10 ) UNSIGNED NOT NULL AUTO_INCREMENT,
     `SessionID` SMALLINT ( 6 ) NOT NULL,
     `ChildType` INT ( 11 ) NOT NULL,
     `State` INT ( 11 ) DEFAULT NULL,
     `Action` INT ( 11 ) DEFAULT NULL,
     PRIMARY KEY ( `id` ) USING BTREE,
     UNIQUE KEY `SesSubID_UNIQUE` ( `SessionID`, `ChildType` ) USING BTREE,
     KEY `SessionID` ( `SessionID` ) USING BTREE
) ENGINE = INNODB AUTO_INCREMENT = 1 DEFAULT CHARSET = utf8;

ALTER TABLE `nccs`.SessionCtrlList ADD DataState int(1);
UPDATE `nccs`.SessionCtrlList SET DataState=1;

CREATE TABLE IF NOT EXISTS `nccs`.`RfChildType` (
    `ID` int(11) NOT NULL AUTO_INCREMENT COMMENT '子类型',
    `RfType` int(11) NOT NULL COMMENT '父类型',
    `Name` varchar(255) NOT NULL COMMENT '子类型名称',
    `IsDefault` tinyint(1) NOT NULL COMMENT '0：正常子类，1：默认子类',
    PRIMARY KEY (`ID`),
    UNIQUE KEY `rfName` (`Name`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;

CREATE TABLE IF NOT EXISTS `nccs`.`SensorProduct` (
    `product_id` INT(11) NOT NULL,
    `name` VARCHAR(64) NOT NULL,
    `mod_bus` SMALLINT(6) NOT NULL,
    `vendor_id` INT(11) NOT NULL,
    `update_time` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
    `create_time` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
    UNIQUE INDEX `product_index` USING BTREE (`product_id` ASC, `vendor_id` ASC))
    ENGINE = InnoDB
    DEFAULT CHARACTER SET = utf8;

CREATE TABLE IF NOT EXISTS `nccs`.`SensorVendor` (
     `id` INT(11) UNSIGNED NOT NULL,
     `name` VARCHAR(64) NOT NULL,
     `update_time` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
     `create_time` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
     PRIMARY KEY (`id`))
    ENGINE = InnoDB
    DEFAULT CHARACTER SET = utf8;

-- D07.03.06
ALTER TABLE `nccs`.`ProjectorType` ADD COLUMN `CmdChannel3` VARCHAR(255) NOT NULL DEFAULT '' AFTER `CmdFromVideo`;
ALTER TABLE `nccs`.`ProjectorType` ADD COLUMN `CmdChannel4` VARCHAR(255) NOT NULL DEFAULT '' AFTER `CmdChannel3`;
CREATE TABLE IF NOT EXISTS   `nccs`.`SessionNoRfCtrlList` (
      `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
      `SessionID` smallint(6) NOT NULL,
      `SubID` int(11) NOT NULL COMMENT '256:中控，257:屏蔽仪，258:电子时钟',
      `State` int(11) DEFAULT NULL,
      `Action` int(11) DEFAULT NULL,
      PRIMARY KEY (`id`) USING BTREE,
      UNIQUE KEY `SesSubID_Type_UNIQUE` (`SessionID`,`SubID`) USING BTREE,
      KEY `SessionID` (`SessionID`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;


-- D07.03.07
DROP PROCEDURE IF EXISTS SectionTable_key_proc;
DELIMITER $$
CREATE PROCEDURE SectionTable_key_proc()
BEGIN
    IF((SELECT COUNT(*) FROM INFORMATION_SCHEMA.STATISTICS WHERE TABLE_NAME = 'SectionTable' AND TABLE_SCHEMA = 'nccs' AND INDEX_NAME = 'PRIMARY') != 0)
    THEN
        ALTER TABLE `nccs`.`SectionTable` DROP PRIMARY KEY;
    END IF;
END $$
DELIMITER ;
CALL SectionTable_key_proc;
DROP PROCEDURE IF EXISTS SectionTable_key_proc;
ALTER TABLE `nccs`.`SectionTable` ADD COLUMN `id` INT(11) UNSIGNED PRIMARY KEY AUTO_INCREMENT NOT NULL FIRST;

-- D07.03.08
UPDATE Users SET User_Desc='' WHERE User_Desc IS NULL;
UPDATE Users SET Pass_Word='' WHERE Pass_Word IS NULL;
UPDATE Users SET Dpm_Sn='' WHERE Dpm_Sn IS NULL;
UPDATE Users SET Dpm_Name='' WHERE Dpm_Name IS NULL;
UPDATE Users SET Priority=100 WHERE Priority IS NULL;
UPDATE Users SET PrivilegeList='' WHERE PrivilegeList IS NULL;
UPDATE Users SET ServerSync=1 WHERE ServerSync IS NULL;
UPDATE Users SET User_Type=2 WHERE User_Type IS NULL;
UPDATE Users SET Mgr_Privilege=0 WHERE Mgr_Privilege IS NULL;
UPDATE Users SET Dev_Privilege=0 WHERE Dev_Privilege IS NULL;
UPDATE Users SET Create_Type=0 WHERE Create_Type IS NULL;
UPDATE Users SET IC_Status=0 WHERE IC_Status IS NULL;
UPDATE Users SET Del_Flag=0 WHERE Del_Flag IS NULL;


ALTER TABLE Users MODIFY COLUMN User_Desc VARCHAR(255)  NOT NULL DEFAULT '' COMMENT '用户登录名';
ALTER TABLE Users MODIFY COLUMN Pass_Word VARCHAR(255)  NOT NULL DEFAULT '' COMMENT 'password, encode with PASSWORD()';
ALTER TABLE Users MODIFY COLUMN Priority INT(11)  NOT NULL DEFAULT 100 COMMENT '用户优先级 值越小。优先级越高';
ALTER TABLE Users MODIFY COLUMN PrivilegeList varchar(4096)  NOT NULL DEFAULT '' COMMENT '用户权限列表';
ALTER TABLE Users MODIFY COLUMN ServerSync TINYINT(4)  NOT NULL DEFAULT 1 COMMENT 'Flag for sync data to cloud server, set when data is inserted or updated, clear after the changed data sysnc to cloud server.';
ALTER TABLE Users MODIFY COLUMN User_Type TINYINT(4)  NOT NULL DEFAULT 2 COMMENT '用户类型：\n1：学生\n2：教师\n3：临时人员 \n4：学校管理员 \n5：平台管理员';
ALTER TABLE Users MODIFY COLUMN Mgr_Privilege TINYINT(1)  NOT NULL DEFAULT 0 COMMENT '设备管理权限标志\n0：具有部分权限，需要查询UserDevices表\n1：具有全部权限，无需查询UserDevices表';
ALTER TABLE Users MODIFY COLUMN Dev_Privilege TINYINT(1)  NOT NULL DEFAULT 0 COMMENT '设备使用权限标志\n0：具有部分权限，需要查询UserDevices表\n1：具有全部权限，无需查询UserDevices表';
ALTER TABLE Users MODIFY COLUMN Create_Type tinyint(1) NOT NULL DEFAULT 0 COMMENT '用户创建类型\n0：手动创建\n1：自动(IC卡同步)创建\n';
ALTER TABLE Users MODIFY COLUMN IC_Status tinyint(1) NOT NULL DEFAULT 0 COMMENT 'IC卡状态\n0：IC卡正常\n1：IC卡挂失';
ALTER TABLE Users MODIFY COLUMN Dpm_Sn varchar(20) NOT NULL DEFAULT "" COMMENT '部门编号';
ALTER TABLE Users MODIFY COLUMN Dpm_Name varchar(100) NOT NULL  DEFAULT "" COMMENT '部门名称';
ALTER TABLE Users MODIFY COLUMN Del_Flag  tinyint(1) NOT NULL DEFAULT 0 COMMENT 'delete flag:\n0: normal\n1: deleted';
-- 增加updatePwdTime
ALTER TABLE Users ADD COLUMN UpdatePwdTime datetime NOT NULL DEFAULT now() COMMENT '密码更新时间。初始化时间为当前时间';

-- ----------------------------
-- Table structure for Graphics
-- ----------------------------
CREATE TABLE IF NOT EXISTS `Graphics`  (
   `ID` int(10) NOT NULL AUTO_INCREMENT COMMENT '模板唯一键值',
   `Name` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '模板的名称',
   `Content` longtext CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '模板的内容',
   `Url` varchar(1028) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '访问模板的url',
   `Sign` int(10) UNSIGNED NOT NULL DEFAULT 0 COMMENT '表示是否有更新',
   `UpdateAt` timestamp(0) NOT NULL DEFAULT CURRENT_TIMESTAMP(0) ON UPDATE CURRENT_TIMESTAMP(0) COMMENT '更新时间',
   PRIMARY KEY (`ID`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

CREATE TABLE IF NOT EXISTS `GraphicSessions` (
     `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '图文任务ID',
     `name` varchar(255) NOT NULL,
     `priority` tinyint(5) unsigned NOT NULL DEFAULT '30',
     `forced` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '1表示强制接收，0表示不强制接收',
     `start_time` datetime NOT NULL COMMENT '任务开始时间',
     `stop_time` datetime NOT NULL COMMENT '任务结束时间',
     `start_time_hms` time NOT NULL COMMENT '存放start_time字段的时分秒',
     `time_style` tinyint(4) NOT NULL DEFAULT '0' COMMENT '重复周期，按照bit位重复,bit0表示周天',
     `status` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '0表示禁止状态，1表示停止状态，2表示运行状态',
     `resource_id` int(10) unsigned NOT NULL COMMENT '图文资源ID',
     `owner` int(11) NOT NULL COMMENT '创建者ID',
     `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
     `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
     PRIMARY KEY (`id`),
     KEY `start_time_hms_index` (`start_time_hms`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `GraphicSessionMember` (
      `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
      `session` int(10) unsigned NOT NULL COMMENT 'IDSessions表id主键值',
      `device` varchar(16) NOT NULL COMMENT '设备ID',
      PRIMARY KEY (`id`),
      UNIQUE KEY `unique_idx` (`device`,`session`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;


-- D07.03.09
CREATE TABLE IF NOT EXISTS `nccs`.`OAuthUser` (
      `ID` int(11) NOT NULL AUTO_INCREMENT COMMENT '主键',
      `Name` varchar(255) NOT NULL COMMENT '用户名',
      `Phone` varchar(50) NOT NULL COMMENT '电话',
      `Info` varchar(255) NOT NULL COMMENT '主要信息',
      PRIMARY KEY (`ID`),
      UNIQUE KEY `ID` (`ID`) USING BTREE,
      UNIQUE KEY `Phone` (`Phone`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `nccs`.`OAuthAppInfo` (
     `OAuthUserID` int(11) NOT NULL COMMENT '第三方用户ID',
     `AppID` varchar(255) NOT NULL,
     `AppSecret` varchar(255) NOT NULL,
     `IsAllPrivilege` bigint(1) NOT NULL COMMENT '0:非全部，1：全部权限',
     `Privilege` varchar(255) NOT NULL COMMENT '以“,”分割的权限字符串',
     `RedirectUrl` varchar(255) NOT NULL COMMENT '回调地址',
     UNIQUE KEY `AppID` (`AppID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE  IF NOT EXISTS `nccs`.`OAuthToken` (
    `AppID` varchar(256) NOT NULL,
    `Token` varchar(255) NOT NULL,
    `TimeOut` datetime NOT NULL COMMENT '过期时间',
    UNIQUE KEY `AppID` (`AppID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


-- D07.03.10
-- 修改DeviceStatistic 表数据
ALTER TABLE `nccs`.DeviceStatistic ADD DataState int(1);
UPDATE `nccs`.DeviceStatistic SET DataState=1 WHERE YEAR(StatisticDay)<>1970;
-- 创建能耗主表
CREATE TABLE IF NOT EXISTS   `nccs`.`DevicePower` (
      `DeviceID` varchar(255) NOT NULL COMMENT '设备ID',
      `StatisticDay` date NOT NULL COMMENT '日期',
      `SubID` int(11) NOT NULL COMMENT '0-31 表示物联。 256,257,258 表示中控、投影、二路投影',
      `PowerConsumed` int(11) NOT NULL COMMENT '单位w',
      `UsedTime` int(11) DEFAULT NULL COMMENT '单位s',
      `SubType` int(11) NOT NULL DEFAULT '0' COMMENT '设备类型，中控、投影仪1、投影1、与SubID 相同。 物联设备 为 RfType',
      UNIQUE KEY `StatisticDay` (`StatisticDay`,`DeviceID`,`SubID`,`SubType`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- D07.03.11
ALTER TABLE `nccs`.`Graphics` ADD COLUMN `Status` tinyint(1) NOT NULL DEFAULT 0 COMMENT '模板是否已经通过审核0：待审核，1：审核通过，2：审核被拒绝' AFTER `Url`;
ALTER TABLE `nccs`.`Graphics` ADD COLUMN `LinkedDev` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '模板关联的设备的ID，一般是演讲型教室的模板' AFTER `Status`;
ALTER TABLE `nccs`.`Graphics` MODIFY COLUMN `Content` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '模板的内容' AFTER `Name`;

ALTER TABLE `nccs`.`SystemLog` MODIFY COLUMN `parameter_detail` varchar(4096) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL AFTER `detail`;

-- D07.03.12
CREATE TABLE IF NOT EXISTS `LogicClasses` (
      `id` int(10) NOT NULL AUTO_INCREMENT,
      `name` varchar(256) NOT NULL,
      `extend_name` varchar(255) NOT NULL DEFAULT '',
      PRIMARY KEY (`id`),
      UNIQUE KEY `nameSchoolIndex` (`name`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;



CREATE TABLE IF NOT EXISTS `LogicClassDevices` (
       `id` int(11) NOT NULL AUTO_INCREMENT,
       `class_id` int(11) NOT NULL,
       `device` varchar(50) NOT NULL,
       PRIMARY KEY (`id`),
       UNIQUE KEY `classDevIndex` (`class_id`,`device`) USING BTREE,
       KEY `devForeignKeyIndex` (`device`) USING BTREE,
       CONSTRAINT `classForeignKey` FOREIGN KEY (`class_id`) REFERENCES `LogicClasses` (`id`) ON DELETE CASCADE ON UPDATE NO ACTION,
       CONSTRAINT `devForeignKey` FOREIGN KEY (`device`) REFERENCES `DeviceList` (`DevID`) ON DELETE CASCADE ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP function IF EXISTS get_child_list;
DELIMITER $$
CREATE function get_child_list(in_id VARCHAR(10)) returns VARCHAR(8000)
BEGIN
    declare ids varchar(8000) default '';
    declare temp_ids varchar(8000);

    SET temp_ids= in_id;
    while temp_ids is NOT NULL do
            SET ids = concat_ws(',',ids,temp_ids);
            SELECT GROUP_CONCAT(`ClassID`) into temp_ids FROM nccs.`DevClasses` WHERE FIND_IN_SET(`Parent`, temp_ids);
        END while;
    return ids;
END $$
DELIMITER ;

insert into  LogicClasses(name,extend_name) select distinct concat(dc.Name,dc.ClassID,pk.`Index`),dc.ClassID from PlayerKeys pk inner join DevClasses dc on dc.ClassID=pk.GroupID;
insert into  LogicClassDevices(class_id, device) SELECT DISTINCT lc.id,dl.DevID FROM LogicClasses lc INNER JOIN DevClasses dc on FIND_IN_SET(dc.ClassID,get_child_list (lc.extend_name))	INNER JOIN DeviceList dl on dl.Parent=dc.ClassID;


DROP function IF EXISTS get_child_list;


-- D07.03.13
ALTER TABLE `nccs`.`PlayerKeys` ADD COLUMN `logic_class` int(1) NOT NULL DEFAULT 0 AFTER `GroupID`;

ALTER TABLE `nccs`.`PlayerKeys` ADD COLUMN `logic_class_id` int(11) NULL DEFAULT NULL AFTER `logic_class`;

ALTER TABLE `nccs`.`PlayerKeys` ADD CONSTRAINT `PlayerLogicClassID` FOREIGN KEY(`logic_class_id`) REFERENCES `nccs`.`LogicClasses` (`id`) ON DELETE SET NULL ON UPDATE SET NULL;

ALTER TABLE `nccs`.`PlayerKeys` ADD COLUMN `name` varchar(255) NOT NULL DEFAULT "" AFTER `logic_class_id`;

update nccs.PlayerKeys inner join LogicClasses lc on lc.extend_name=GroupID inner join  DevClasses dc on dc.ClassID=GroupID set logic_class=1,logic_class_id=lc.id,nccs.PlayerKeys.name=dc.Name;

update  LogicClasses set extend_name=name;


CREATE TABLE IF NOT EXISTS `nccs`.`Firmware` (
     `id` int(10) NOT NULL AUTO_INCREMENT,
     `name` varchar(256) NOT NULL,
     `chip` varchar(32) NOT NULL DEFAULT '',
     `pre` varchar(255) NOT NULL DEFAULT '',
     `md5` varchar(255) NOT NULL DEFAULT '',
     `notes` varchar(1024) NOT NULL DEFAULT '',
     `version` int(11) NOT NULL DEFAULT 0,
     `file_path` varchar(128) NOT NULL DEFAULT '',
     `update_time` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
     `create_time` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
     PRIMARY KEY (`id`),
     UNIQUE KEY `nameIndex` (`name`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

-- D07.03.14
DELETE `nccs`.`PlaySessionTime` from `nccs`.`PlaySessionTime` left join `nccs`.`PlaySessions` t2 Using (SessionID) where t2.SessionID is null;
ALTER TABLE `nccs`.`PlaySessionTime` ADD CONSTRAINT `sIDForeignKey` FOREIGN KEY (`SessionID`) REFERENCES `nccs`.`PlaySessions` (`SessionID`) ON DELETE CASCADE ON UPDATE NO ACTION;


-- D07.03.15
CREATE TABLE IF NOT EXISTS `nccs`.`EnvDataCh2o`  (
         `ReportDate` datetime(0) NOT NULL,
         `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备ID',
         `Val` float(11, 2) NOT NULL,
         UNIQUE INDEX `INDEX`(`ReportDate`, `DeviceID`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;


CREATE TABLE IF NOT EXISTS `nccs`.`EnvDataCo2`  (
        `ReportDate` datetime(0) NOT NULL,
        `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备ID',
        `Val` float(11, 2) NOT NULL,
        UNIQUE INDEX `INDEX`(`ReportDate`, `DeviceID`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

CREATE TABLE  IF NOT EXISTS `nccs`.`EnvDataHumidity`  (
          `ReportDate` datetime(0) NOT NULL,
          `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备ID',
          `Val` float(11, 2) NOT NULL,
          UNIQUE INDEX `INDEX`(`ReportDate`, `DeviceID`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

CREATE TABLE IF NOT EXISTS `nccs`.`EnvDataInfrared`  (
         `ReportDate` datetime(0) NOT NULL,
         `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备ID',
         `Val` int(11) NOT NULL,
         UNIQUE INDEX `INDEX`(`ReportDate`, `DeviceID`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

CREATE TABLE IF NOT EXISTS `nccs`.`EnvDataLight`  (
          `ReportDate` datetime(0) NOT NULL,
          `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备ID',
          `Val` float(11, 2) NOT NULL,
          UNIQUE INDEX `INDEX`(`ReportDate`, `DeviceID`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

CREATE TABLE  IF NOT EXISTS `nccs`.`EnvDataNoise`  (
           `ReportDate` datetime(0) NOT NULL,
           `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备ID',
           `Val` float(11, 2) NOT NULL,
           UNIQUE INDEX `INDEX`(`ReportDate`, `DeviceID`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

CREATE TABLE IF NOT EXISTS `nccs`.`EnvDataPm2dot5`  (
            `ReportDate` datetime(0) NOT NULL,
            `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备ID',
            `Val` float(11, 2) NOT NULL,
            UNIQUE INDEX `INDEX`(`ReportDate`, `DeviceID`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

CREATE TABLE IF NOT EXISTS  `nccs`.`EnvDataRadar`  (
           `ReportDate` datetime(0) NOT NULL,
           `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备ID',
           `Val` int(11) NOT NULL,
           UNIQUE INDEX `INDEX`(`ReportDate`, `DeviceID`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

CREATE TABLE IF NOT EXISTS `nccs`.`EnvDataTemperature`  (
        `SchoolID` int(11) NOT NULL DEFAULT 0 COMMENT '学校id',
        `ReportDate` datetime(0) NOT NULL,
        `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备ID',
        `Val` float(11, 2) NOT NULL,
        UNIQUE INDEX `INDEX`(`SchoolID`, `ReportDate`, `DeviceID`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

CREATE TABLE IF NOT EXISTS  `nccs`.`EnvDataTvoc`  (
      `ReportDate` datetime(0) NOT NULL,
      `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备ID',
      `Val` float(11, 2) NOT NULL,
      UNIQUE INDEX `INDEX`(`ReportDate`, `DeviceID`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;


-- D07.03.17
CREATE TABLE IF NOT EXISTS `Student` (
         `Number` varchar(255) NOT NULL DEFAULT '' COMMENT '学生证号码',
         `Name` varchar(255) NOT NULL DEFAULT '' COMMENT '姓名',
         `College` varchar(255) NOT NULL DEFAULT '' COMMENT '学院',
         `Grade` int(11) NOT NULL DEFAULT '0' COMMENT '年级(毕业年份)',
         `Class` varchar(255) NOT NULL DEFAULT '' COMMENT '专业班级',
         `Mobile` varchar(255) NOT NULL DEFAULT '' COMMENT '手机号码',
         `SchoolID` int(11) NOT NULL DEFAULT '0' COMMENT '学校ID',
         PRIMARY KEY (`Number`),
         KEY `mobile` (`Mobile`),
         KEY `name` (`Name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='学生信息对接表';

CREATE TABLE IF NOT EXISTS `RegisterUser` (
          `UserAccount` varchar(255) NOT NULL DEFAULT '' COMMENT '用户账号（下划线开头的是系统用户）',
          `Phone` varchar(255) NOT NULL DEFAULT '' COMMENT '电话号码',
          `User_ID` int(11) NOT NULL DEFAULT '-5' COMMENT '系统用户ID',
          `UserType` enum('student','teacher','other') NOT NULL DEFAULT 'student' COMMENT '用户类型（student-学生 teacher-教职工 other-其他人员）',
          `UserName` varchar(255) NOT NULL DEFAULT '' COMMENT '注册姓名',
          `UserCollege` varchar(255) NOT NULL DEFAULT '' COMMENT '注册学院',
          `UserGrade` int(11) NOT NULL DEFAULT '2019' COMMENT '注册年级',
          `UserClass` varchar(255) NOT NULL DEFAULT '' COMMENT '注册班级',
          `UserNumber` varchar(255) NOT NULL DEFAULT '' COMMENT '注册学工号',
          `SchoolID` int(11) NOT NULL DEFAULT '0' COMMENT '注册学校ID',
          `SchoolName` varchar(255) NOT NULL DEFAULT '' COMMENT '注册学校名称',
          `AddTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '注册时间',
          `ActiveTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '最后参与时间',
          `MatchStatus` tinyint(4) NOT NULL DEFAULT '0' COMMENT '学生匹配状态(0-未匹配 1-匹配成功 -1-匹配失败)',
          `MatchID` int(11) NOT NULL DEFAULT '0' COMMENT '匹配ID（匹配当时 user或student 表中的ID）',
          `MatchName` varchar(255) NOT NULL DEFAULT '' COMMENT '匹配姓名',
          `MatchCollege` varchar(255) NOT NULL DEFAULT '' COMMENT '匹配学院',
          `MatchGrade` int(11) NOT NULL DEFAULT '2019' COMMENT '匹配年级',
          `MatchClass` varchar(255) NOT NULL DEFAULT '' COMMENT '匹配班级',
          `MatchNumber` varchar(255) NOT NULL DEFAULT '' COMMENT '匹配学工号',
          `MatchMobile` varchar(255) NOT NULL DEFAULT '' COMMENT '匹配手机号码',
          `MatchSchoolID` int(11) NOT NULL DEFAULT '0' COMMENT '匹配学校ID',
          `AuditStatus` tinyint(4) NOT NULL DEFAULT '0' COMMENT '审核状态（0-未审核  1-审核已通过 -1-审核未通过）',
          `AuditUserID` int(11) NOT NULL DEFAULT '0' COMMENT '审核用户ID',
          `AuditUserName` varchar(255) NOT NULL DEFAULT '' COMMENT '审核用户姓名',
          `AuditTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '审核时间',
          `ReserveTotal` int(11) NOT NULL DEFAULT '0' COMMENT '教室预约次数',
          `ReservePass` int(11) NOT NULL DEFAULT '0' COMMENT '教室预约成功次数',
          `ReserveCancel` int(11) NOT NULL DEFAULT '0' COMMENT '教室预约取消次数',
          `ReserveUse` int(11) NOT NULL DEFAULT '0' COMMENT '预约使用次数',
          `ReserveActive` int(11) NOT NULL DEFAULT '0' COMMENT '教室预约有效数量（列表可见）',
          `ReserveHistory` int(11) NOT NULL DEFAULT '0' COMMENT '历史记录数',
          PRIMARY KEY (`UserAccount`),
          KEY `phone` (`Phone`),
          KEY `userID` (`User_ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='注册用户';

CREATE TABLE IF NOT EXISTS `DeviceReserve` (
       `ID` int(11) NOT NULL AUTO_INCREMENT COMMENT '预约ID',
       `User_ID` int(11) NOT NULL DEFAULT '-5' COMMENT '系统用户的用户ID',
       `UserMobile` varchar(255) NOT NULL DEFAULT '' COMMENT '用户手机号码',
       `UserType` enum('student','other','teacher') NOT NULL DEFAULT 'student' COMMENT '用户类型',
       `UserName` varchar(255) NOT NULL DEFAULT '' COMMENT '姓名',
       `UserCollege` varchar(255) NOT NULL DEFAULT '' COMMENT '所属学院',
       `UserGrade` int(11) NOT NULL DEFAULT '2019' COMMENT '所属年级',
       `UserClass` varchar(255) NOT NULL DEFAULT '' COMMENT '所属班级',
       `UserNumber` varchar(255) NOT NULL DEFAULT '' COMMENT '学工号',
       `SchoolID` int(11) NOT NULL DEFAULT '0' COMMENT '申请学校ID',
       `SchoolName` varchar(255) NOT NULL DEFAULT '' COMMENT '申请学校名称',
       `MatchStatus` tinyint(4) NOT NULL DEFAULT '0' COMMENT '匹配状态(0-未匹配 1-匹配成功 -1-匹配失败)',
       `MatchID` int(11) NOT NULL DEFAULT '0' COMMENT '匹配ID（匹配当时 user或student 表中的ID）',
       `MatchName` varchar(255) NOT NULL DEFAULT '' COMMENT '匹配姓名',
       `MatchCollege` varchar(255) NOT NULL DEFAULT '' COMMENT '匹配学院',
       `MatchGrade` int(11) NOT NULL DEFAULT '2019' COMMENT '匹配年级',
       `MatchClass` varchar(255) NOT NULL DEFAULT '' COMMENT '匹配班级',
       `MatchNumber` varchar(255) NOT NULL DEFAULT '' COMMENT '匹配学工号',
       `MatchMobile` varchar(255) NOT NULL DEFAULT '' COMMENT '匹配手机号码',
       `MatchSchoolID` int(11) NOT NULL DEFAULT '0' COMMENT '匹配学校ID',
       `MatchSchoolName` varchar(255) NOT NULL DEFAULT '' COMMENT '匹配学校',
       `ClassID` int(11) NOT NULL DEFAULT '0' COMMENT '设备分区ID',
       `ClassName` varchar(255) NOT NULL DEFAULT '' COMMENT '设备分区名称（教学楼）',
       `DeviceID` varchar(255) NOT NULL DEFAULT '' COMMENT '设备ID',
       `DeviceName` varchar(255) NOT NULL DEFAULT '' COMMENT '设备名称（教室）',
       `DeviceDescription` varchar(255) NOT NULL DEFAULT '' COMMENT '设备位置',
       `DeviceExt` varchar(255) NOT NULL DEFAULT '' COMMENT '扩展设备ID,英文逗号分割（双师课堂一个教室有两个设备）',
       `StartTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '开始时间',
       `EndTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '结束时间',
       `Reason` varchar(255) NOT NULL DEFAULT '' COMMENT '预约原因',
       `ApplyTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '申请时间',
       `ModifyTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '修改时间',
       `AuditStatus` tinyint(4) NOT NULL DEFAULT '0' COMMENT '审核状态（0-未审核  1-审核未通过 2-审核已通过 -1-审核已过期）',
       `AuditUserID` int(11) NOT NULL DEFAULT '0' COMMENT '审核用户ID',
       `AuditUserName` varchar(255) NOT NULL DEFAULT '' COMMENT '审核用户姓名',
       `AuditTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '审核时间',
       `AuditInfo` varchar(255) NOT NULL DEFAULT '' COMMENT '审核备注信息',
       `CancelStatus` tinyint(4) NOT NULL DEFAULT '0' COMMENT '取消状态（0-未取消  1-用户自己取消 2-管理员取消）',
       `CancelUserID` int(11) NOT NULL DEFAULT '0' COMMENT '取消用户ID （管理员取消才有值）',
       `CancelUserName` varchar(255) NOT NULL DEFAULT '' COMMENT '取消用户姓名（管理员取消才有值）',
       `CancelTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '取消时间',
       `CancelReason` varchar(255) NOT NULL DEFAULT '' COMMENT '取消原因',
       `UseQrCode` varchar(255) NOT NULL DEFAULT '' COMMENT '反向扫码二维码',
       `UseStatus` tinyint(4) NOT NULL DEFAULT '0' COMMENT '使用状态（0-未使用 1-已使用）',
       `UseDeviceID` tinyint(4) NOT NULL DEFAULT '0' COMMENT '是否使用设备(0-未使用 1-已使用)',
       `UseDeviceExt` tinyint(4) NOT NULL DEFAULT '0' COMMENT '是否使用扩展设备(0-未使用 1-已使用)',
       `UseCount` int(11) NOT NULL DEFAULT '0' COMMENT '使用次数',
       `UseTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '使用时间',
       `UseDevice` varchar(255) NOT NULL DEFAULT '' COMMENT '使用设备ID',
       PRIMARY KEY (`ID`),
       KEY `mobile` (`UserMobile`),
       KEY `number` (`UserNumber`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COMMENT='教室预约';

CREATE TABLE IF NOT EXISTS `DeviceReserveHistory` (
      `ID` int(11) NOT NULL COMMENT '预约ID',
      `User_ID` int(11) NOT NULL DEFAULT '-5' COMMENT '系统用户的用户ID',
      `UserMobile` varchar(255) NOT NULL DEFAULT '' COMMENT '用户手机号码',
      `UserType` enum('student','teacher','other') NOT NULL DEFAULT 'student' COMMENT '用户类型',
      `UserName` varchar(255) NOT NULL DEFAULT '' COMMENT '姓名',
      `UserCollege` varchar(255) NOT NULL DEFAULT '' COMMENT '所属学院',
      `UserGrade` int(11) NOT NULL DEFAULT '2019' COMMENT '所属年级',
      `UserClass` varchar(255) NOT NULL DEFAULT '' COMMENT '所属班级',
      `UserNumber` varchar(255) NOT NULL DEFAULT '' COMMENT '学工号',
      `SchoolID` int(11) NOT NULL DEFAULT '0' COMMENT '申请学校ID',
      `SchoolName` varchar(255) NOT NULL DEFAULT '' COMMENT '申请学校名称',
      `MatchStatus` tinyint(4) NOT NULL DEFAULT '0' COMMENT '匹配状态(0-未匹配 1-匹配成功 -1-匹配失败)',
      `MatchID` int(11) NOT NULL DEFAULT '0' COMMENT '匹配ID（匹配当时 user或student 表中的ID）',
      `MatchName` varchar(255) NOT NULL DEFAULT '' COMMENT '匹配姓名',
      `MatchCollege` varchar(255) NOT NULL DEFAULT '' COMMENT '匹配学院',
      `MatchGrade` int(11) NOT NULL DEFAULT '2019' COMMENT '匹配年级',
      `MatchClass` varchar(255) NOT NULL DEFAULT '' COMMENT '匹配班级',
      `MatchNumber` varchar(255) NOT NULL DEFAULT '' COMMENT '匹配学工号',
      `MatchMobile` varchar(255) NOT NULL DEFAULT '' COMMENT '匹配手机号码',
      `MatchSchoolID` int(11) NOT NULL DEFAULT '0' COMMENT '匹配学校ID',
      `MatchSchoolName` varchar(255) NOT NULL DEFAULT '' COMMENT '匹配学校',
      `ClassID` int(11) NOT NULL DEFAULT '0' COMMENT '设备分区ID',
      `ClassName` varchar(255) NOT NULL DEFAULT '' COMMENT '设备分区名称（教学楼）',
      `DeviceID` varchar(255) NOT NULL DEFAULT '' COMMENT '设备ID',
      `DeviceName` varchar(255) NOT NULL DEFAULT '' COMMENT '设备名称（教室）',
      `DeviceExt` varchar(255) NOT NULL DEFAULT '' COMMENT '扩展设备ID,英文逗号分割（双师课堂一个教室有两个设备）',
      `DeviceDescription` varchar(255) NOT NULL DEFAULT '' COMMENT '设备位置',
      `StartTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '开始时间',
      `EndTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '结束时间',
      `Reason` varchar(255) NOT NULL DEFAULT '' COMMENT '预约原因',
      `ApplyTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '申请时间',
      `ModifyTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '修改时间',
      `AuditStatus` tinyint(4) NOT NULL DEFAULT '0' COMMENT '审核状态（0-未审核  1-审核已通过 -1-审核未通过）',
      `AuditUserID` int(11) NOT NULL DEFAULT '0' COMMENT '审核用户ID',
      `AuditUserName` varchar(255) NOT NULL DEFAULT '' COMMENT '审核用户姓名',
      `AuditTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '审核时间',
      `AuditInfo` varchar(255) NOT NULL DEFAULT '' COMMENT '审核备注信息',
      `CancelStatus` tinyint(4) NOT NULL DEFAULT '0' COMMENT '取消状态（0-未取消  1-用户自己取消 2-管理员取消）',
      `CancelUserID` int(11) NOT NULL DEFAULT '0' COMMENT '取消用户ID （管理员取消才有值）',
      `CancelUserName` varchar(255) NOT NULL DEFAULT '' COMMENT '取消用户姓名（管理员取消才有值）',
      `CancelTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '取消时间',
      `CancelReason` varchar(255) NOT NULL DEFAULT '' COMMENT '取消原因',
      `UseQrCode` varchar(255) NOT NULL DEFAULT '' COMMENT '反向扫码二维码',
      `UseStatus` tinyint(4) NOT NULL DEFAULT '0' COMMENT '使用状态（0-未使用 1-已使用）',
      `UseDeviceID` tinyint(4) NOT NULL DEFAULT '0' COMMENT '是否使用设备(0-未使用 1-已使用)',
      `UseDeviceExt` tinyint(4) NOT NULL DEFAULT '0' COMMENT '是否使用扩展设备(0-未使用 1-已使用)',
      `UseCount` int(11) NOT NULL DEFAULT '0' COMMENT '使用次数',
      `UseTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '使用时间',
      `UseDevice` varchar(255) NOT NULL DEFAULT '' COMMENT '使用设备ID',
      PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='教室预约历史数据';


-- D07.03.18
-- 将40（BC02）,48(BC03)开头的设备的devType 的bit0 (是否有集控功能)置为0
UPDATE DeviceList SET DevType=DevType&~1 WHERE SUBSTR(DevID,1,2) IN ('40','48');

CREATE TABLE IF NOT EXISTS `nccs`.`DevUsedStatus`  (
       `DevID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '融合终端，音视频直转播终端，mic等设备的ID(因为mic可能从一个设备挪到另一个设备使用所以单独为mic创建记录)',
       `Type` int(10) NOT NULL COMMENT '用于区分设备类型(0:融合终端 1:空调 2:电源 10:音视频直转播终端 11:麦克风 12:网关设备  )',
       `Status` enum('offline','online','pwrOn','pwrOff','using','isPushing') CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT 'offline:离线 online:在线 pwrOn:开机 pwrOff:关机 using:使用中 isPushing:推流中',
       `ContinueOffline` tinyint(10) NOT NULL DEFAULT 0 COMMENT '当status= offline时有效。1：表示设备当天一直离线 0：表示离线后又上线',
       `UpdateDate` date NOT NULL DEFAULT '2022-04-19' COMMENT 'mic和充电桩上报该状态时的时间',
       `Count` int(10) NOT NULL COMMENT '设备切换为该状态的次数',
       `SchoolID` int(10) NOT NULL COMMENT '所在学校ID',
       UNIQUE INDEX `Dev_Status_Date`(`DevID`, `Status`, `UpdateDate`, `SchoolID`, `Type`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;


CREATE TABLE IF NOT EXISTS `nccs`.`MicPhoneList`  (
      `id` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT 'mic的id',
      `name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT 'mic的名称',
      `mic_type` int(32) NOT NULL DEFAULT 0 COMMENT '麦克风类型',
      `last_dev_id` varchar(255) NOT NULL DEFAULT '' COMMENT '最近一次归属的设备ID',
      `charge_count` int(32) NOT NULL DEFAULT 0 COMMENT '充电次数',
      `update_time` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
      `create_time` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
      PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

CREATE TABLE IF NOT EXISTS `nccs`.`MicStubList`  (
     `id` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '充电桩id',
     `name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '充电桩名称',
     `stub_type` int(32) NOT NULL DEFAULT 0 COMMENT '充电桩类型',
     `last_dev_id` varchar(255) NOT NULL DEFAULT '' COMMENT '最近一次归属的设备ID',
     `update_time` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
     `create_time` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
     PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;





CREATE TABLE IF NOT EXISTS `nccs`.`SessionHistory` (
       `SessionID` smallint(6) NOT NULL COMMENT '任务ID',
       `SessionStreamType` tinyint(4) NOT NULL COMMENT '任务内容类型',
       `SourceMode` tinyint(4) NOT NULL COMMENT '来源方式',
       `SessionType` tinyint(4) NOT NULL COMMENT '任务类型',
       `SessionName` varchar(50) NOT NULL COMMENT '任务名称',
       `ScheduleID` int(11) NOT NULL COMMENT '执行时间ID，手动任务为0',
       `ScheduleTime` time NOT NULL COMMENT '执行时间',
       `Status` tinyint(4) NOT NULL COMMENT '执行状态 0：待执行，1:执行中，2：执行成功，3：执行失败',
       `HistoryDate` date NOT NULL COMMENT '任务当日时间',
       UNIQUE KEY `SessionID` (`SessionID`,`ScheduleID`,`HistoryDate`,`ScheduleTime`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


-- 图文任务表增加停止播放时间字段
ALTER TABLE `nccs`.`GraphicSessions` ADD COLUMN `update_status_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '任务状态更新时间' AFTER `create_time` ;

CREATE TABLE IF NOT EXISTS `nccs`.`ReportData` (
       `table_id` int(11) NOT NULL COMMENT '报表ID',
       `row_id` varchar(255) NOT NULL COMMENT '报表周期 例：按月分组 ‘2022-01’，‘2022-02’',
       `header_column_id` int(11) NOT NULL COMMENT '子项关联ID',
       `base_id` varchar(255) NOT NULL COMMENT '按设备统计含义为 ：device_id 。按学校统计 含义为 ：school_id 按学校-设备统计：school_id-device-id ',
       `val` varchar(255) NOT NULL COMMENT '具体数据值',
       UNIQUE KEY `table_id` (`table_id`,`row_id`,`header_column_id`,`base_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 移除掉无物联控制的物联配置
DELETE `nccs`.`RfConfig` FROM `nccs`.`RfConfig` INNER JOIN DeviceList b on b.DevID=`nccs`.`RfConfig`.DevID WHERE b.DevType&0x20=0;

-- D07.03.19
CREATE TABLE IF NOT EXISTS `nccs`.`DevOfflineTime`  (
    `dev_id` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备ID',
    `type` int(11) NOT NULL COMMENT '用于区分设备类型(0:融合终端 1:空调 2:电源 10:音视频直转播终端 11:麦克风 12:网关设备  )',
    `offline_time_unix` int(11) NOT NULL COMMENT '离线时间戳',
    `update_at` timestamp(0) NOT NULL DEFAULT CURRENT_TIMESTAMP(0) ON UPDATE CURRENT_TIMESTAMP(0) COMMENT '日期和时间',
    UNIQUE INDEX `school_dev`(`dev_id`, `type`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

ALTER TABLE `nccs`.`DevUsedStatus` DROP COLUMN `ContinueOffline`;

-- D07.03.20

ALTER TABLE `nccs`.`SensorVendor` ADD COLUMN `from_cloud` tinyint(1) NOT NULL DEFAULT 0;
ALTER TABLE `nccs`.`SensorProduct` ADD COLUMN `from_cloud` tinyint(1) NOT NULL DEFAULT 0;
ALTER TABLE `nccs`.`EnvironmentalParameters` ADD COLUMN `from_cloud` tinyint(1) NOT NULL DEFAULT 0;

ALTER TABLE `nccs`.`SessionHistory` MODIFY COLUMN `SessionStreamType` tinyint(4) UNSIGNED NOT NULL COMMENT '任务内容类型，与任务表相同' AFTER `SessionID`;

ALTER TABLE `nccs`.`SessionHistory` MODIFY COLUMN `SessionType` tinyint(4) NOT NULL COMMENT '任务类型，与任务表相同' AFTER `SourceMode`;

CREATE TABLE `nccs`.`ThirdClassDevices`  (
     `third_class_id` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
     `dev_id` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
     `app_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
     UNIQUE INDEX `third_class_id_index`(`third_class_id`, `app_id`) USING BTREE,
     UNIQUE INDEX `dev_id_index`(`dev_id`, `app_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

-- D07.03.22
ALTER TABLE `nccs`.`ProjectorType` ADD COLUMN `ChangedFromLocal` tinyint(1) NOT NULL DEFAULT 0 COMMENT '值为1时表示投影机是否被用户在本地服务器修改过(本地添加的型号和本地修改过的投影机型号)' AFTER `CmdChannel4`;


-- D07.03.31
UPDATE Firmware SET pre='ncxx,bc02,bc03' WHERE pre='00,20,28,40,48';
UPDATE Firmware SET pre='tm03' WHERE pre='50,58';
UPDATE Firmware SET pre='bc01' WHERE pre='49';


SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;
