-- MySQL Workbench Synchronization
-- Generated: 2022-05-06 14:33:28
-- Model: nccs
-- Version: D07.03.26
-- Project: idsteServers
-- Author:


SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL,ALLOW_INVALID_DATES';
-- D08.01.01
DROP TABLE IF EXISTS `nccs`.`CallWaiter`;
DROP TABLE IF EXISTS `nccs`.`DeviceDesiredStaus`;
DROP TABLE IF EXISTS `nccs`.`DeviceStatus`;
DROP TABLE IF EXISTS `nccs`.`DeviceStatusExt`;
DROP TABLE IF EXISTS `nccs`.`DisableDevSession`;
DROP TABLE IF EXISTS `nccs`.`IpCall`;
DROP TABLE IF EXISTS `nccs`.`IpCameraRtmp`;
DROP TABLE IF EXISTS `nccs`.`LastProcessedTime`;
DROP TABLE IF EXISTS `nccs`.`MsgTaskDev`;
DROP TABLE IF EXISTS `nccs`.`MsgTasks`;
DROP TABLE IF EXISTS `nccs`.`NotificationMsg`;
DROP TABLE IF EXISTS `nccs`.`PlayerAlive`;
DROP TABLE IF EXISTS `nccs`.`SrsServer`;
DROP TABLE IF EXISTS `nccs`.`SrsServerStatus`;
DROP TABLE IF EXISTS `nccs`.`DeviceCtrlSchedule`;
DROP TABLE IF EXISTS `nccs`.`GroupCtrlSchedule`;
DROP TABLE IF EXISTS `nccs`.`Messages`;

DROP TABLE IF EXISTS `nccs`.`SchoolInfo`;
DROP TABLE IF EXISTS `nccs`.`UserSchools`;

update `nccs`.`Users` set `User_Type` = 4,`IsSuper` = 1 where `User_Type` = 5;
/*
   部分已有的权限调整
*/
update `nccs`.`Users` set `PrivilegeList` = replace(`PrivilegeList`, "1005", "2009");
update `nccs`.`Users` set `PrivilegeList` = replace(`PrivilegeList`, "1008", "4005");
update `nccs`.`Users` set `PrivilegeList` = replace(`PrivilegeList`, "1009", "4006");


-- DevUsedStatus
CREATE TABLE IF NOT EXISTS `nccs`.`DevUsedStatusV2` (
   `id` int(11) NOT NULL  AUTO_INCREMENT,
  `DevID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '融合终端，音视频直转播终端，mic等设备的ID(因为mic可能从一个设备挪到另一个设备使用所以单独为mic创建记录)',
  `Type` int(10) NOT NULL COMMENT '用于区分设备类型(0:融合终端 1:空调 2:电源 10:音视频直转播终端 11:麦克风 12:网关设备  )',
  `Status` enum('offline','online','pwrOn','pwrOff','using','isPushing') CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT 'offline:离线 online:在线 pwrOn:开机 pwrOff:关机 using:使用中 isPushing:推流中',
  `UpdateDate` date NOT NULL DEFAULT '2022-04-19' COMMENT 'mic和充电桩上报该状态时的时间',
  `Count` int(10) NOT NULL COMMENT '设备切换为该状态的次数',
  UNIQUE INDEX `Dev_Status_Date`(`DevID`, `Status`, `UpdateDate`, `Type`) USING BTREE,
  PRIMARY KEY (`id`)
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

insert into `nccs`.`DevUsedStatusV2` (`DevID`,`Type`,`Status`,`UpdateDate`, `Count`) (select `DevID`,`Type`,`Status`,`UpdateDate`,sum(`Count`) from `nccs`.`DevUsedStatus` group by `DevID`,`Type`,`Status`,`UpdateDate`) ;


-- EnvDataCh2oV2
CREATE TABLE IF NOT EXISTS `nccs`.`EnvDataCh2oV2`  (
    `id` int(10) NOT NULL AUTO_INCREMENT,
    `ReportDate` datetime(0) NOT NULL,
    `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备ID',
    `Val` float(11, 2) NOT NULL,
    UNIQUE INDEX `INDEX`(`ReportDate`, `DeviceID`) USING BTREE,
    PRIMARY KEY (`id`)
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

insert into `nccs`.`EnvDataCh2oV2` (`ReportDate`,`DeviceID`,`Val`) (select `ReportDate`,`DeviceID`,sum(`Val`) from `nccs`.`EnvDataCh2o` group by `ReportDate`,`DeviceID`) ;

-- EnvDataCo2V2
CREATE TABLE IF NOT EXISTS `nccs`.`EnvDataCo2V2`  (
    `id` int(10) NOT NULL AUTO_INCREMENT,
    `ReportDate` datetime(0) NOT NULL,
    `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备ID',
    `Val` float(11, 2) NOT NULL,
    UNIQUE INDEX `INDEX`(`ReportDate`, `DeviceID`) USING BTREE,
    PRIMARY KEY (`id`)
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

insert into `nccs`.`EnvDataCo2V2` (`ReportDate`,`DeviceID`,`Val`) (select `ReportDate`,`DeviceID`,sum(`Val`) from `nccs`.`EnvDataCo2` group by `ReportDate`,`DeviceID`) ;

-- EnvDataHumidityV2
CREATE TABLE  IF NOT EXISTS `nccs`.`EnvDataHumidityV2`  (
    `id` int(10) NOT NULL AUTO_INCREMENT,
    `ReportDate` datetime(0) NOT NULL,
    `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备ID',
    `Val` float(11, 2) NOT NULL,
    UNIQUE INDEX `INDEX`(`ReportDate`, `DeviceID`) USING BTREE,
    PRIMARY KEY (`id`)
    ) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;
insert into `nccs`.`EnvDataHumidityV2` (`ReportDate`,`DeviceID`,`Val`) (select `ReportDate`,`DeviceID`,sum(`Val`) from `nccs`.`EnvDataHumidity` group by `ReportDate`,`DeviceID`) ;

-- EnvDataInfraredV2
CREATE TABLE IF NOT EXISTS `nccs`.`EnvDataInfraredV2`  (
    `id` int(10) NOT NULL AUTO_INCREMENT,
    `ReportDate` datetime(0) NOT NULL,
    `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备ID',
    `Val` int(11) NOT NULL,
    UNIQUE INDEX `INDEX`(`ReportDate`, `DeviceID`) USING BTREE,
    PRIMARY KEY (`id`)
    ) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;
insert into `nccs`.`EnvDataInfraredV2` (`ReportDate`,`DeviceID`,`Val`) (select `ReportDate`,`DeviceID`,sum(`Val`) from `nccs`.`EnvDataInfrared` group by `ReportDate`,`DeviceID`) ;

-- EnvDataLightV2
CREATE TABLE IF NOT EXISTS `nccs`.`EnvDataLightV2`  (
    `id` int(10) NOT NULL AUTO_INCREMENT,
    `ReportDate` datetime(0) NOT NULL,
    `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备ID',
    `Val` float(11, 2) NOT NULL,
    UNIQUE INDEX `INDEX`(`ReportDate`, `DeviceID`) USING BTREE,
    PRIMARY KEY (`id`)
    ) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;
insert into `nccs`.`EnvDataLightV2` (`ReportDate`,`DeviceID`,`Val`) (select `ReportDate`,`DeviceID`,sum(`Val`) from `nccs`.`EnvDataLight` group by `ReportDate`,`DeviceID`) ;

-- EnvDataNoiseV2
CREATE TABLE  IF NOT EXISTS `nccs`.`EnvDataNoiseV2`  (
    `id` int(10) NOT NULL AUTO_INCREMENT,
    `ReportDate` datetime(0) NOT NULL,
    `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备ID',
    `Val` float(11, 2) NOT NULL,
    UNIQUE INDEX `INDEX`(`ReportDate`, `DeviceID`) USING BTREE,
    PRIMARY KEY (`id`)
    ) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;
insert into `nccs`.`EnvDataNoiseV2` (`ReportDate`,`DeviceID`,`Val`) (select `ReportDate`,`DeviceID`,sum(`Val`) from `nccs`.`EnvDataNoise` group by `ReportDate`,`DeviceID`) ;

-- EnvDataPm2dot5V2
CREATE TABLE IF NOT EXISTS `nccs`.`EnvDataPm2dot5V2`  (
    `id` int(10) NOT NULL AUTO_INCREMENT,
    `ReportDate` datetime(0) NOT NULL,
    `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备ID',
    `Val` float(11, 2) NOT NULL,
    UNIQUE INDEX `INDEX`(`ReportDate`, `DeviceID`) USING BTREE,
    PRIMARY KEY (`id`)
    ) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;
insert into `nccs`.`EnvDataPm2dot5V2` (`ReportDate`,`DeviceID`,`Val`) (select `ReportDate`,`DeviceID`,sum(`Val`) from `nccs`.`EnvDataPm2dot5` group by `ReportDate`,`DeviceID`) ;

-- EnvDataRadarV2
CREATE TABLE IF NOT EXISTS  `nccs`.`EnvDataRadarV2`  (
    `id` int(10) NOT NULL AUTO_INCREMENT,
    `ReportDate` datetime(0) NOT NULL,
    `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备ID',
    `Val` int(11) NOT NULL,
    UNIQUE INDEX `INDEX`(`ReportDate`, `DeviceID`) USING BTREE,
    PRIMARY KEY (`id`)
    ) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;
insert into `nccs`.`EnvDataRadarV2` (`ReportDate`,`DeviceID`,`Val`) (select `ReportDate`,`DeviceID`,sum(`Val`) from `nccs`.`EnvDataRadar` group by `ReportDate`,`DeviceID`) ;

-- EnvDataTemperatureV2
CREATE TABLE IF NOT EXISTS `nccs`.`EnvDataTemperatureV2`  (
    `id` int(10) NOT NULL AUTO_INCREMENT,
    `ReportDate` datetime(0) NOT NULL,
    `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备ID',
    `Val` float(11, 2) NOT NULL,
    UNIQUE INDEX `INDEX`(`ReportDate`, `DeviceID`) USING BTREE,
    PRIMARY KEY (`id`)
    ) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;
insert into `nccs`.`EnvDataTemperatureV2` (`ReportDate`,`DeviceID`,`Val`) (select `ReportDate`,`DeviceID`,sum(`Val`) from `nccs`.`EnvDataTemperature` group by `ReportDate`,`DeviceID`) ;

-- EnvDataTvocV2
CREATE TABLE IF NOT EXISTS  `nccs`.`EnvDataTvocV2` (
    `id` int(10) NOT NULL AUTO_INCREMENT,
    `ReportDate` datetime(0) NOT NULL,
    `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备ID',
    `Val` float(11, 2) NOT NULL,
    UNIQUE INDEX `INDEX`(`ReportDate`, `DeviceID`) USING BTREE,
    PRIMARY KEY (`id`)
    ) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;
insert into `nccs`.`EnvDataTvocV2` (`ReportDate`,`DeviceID`,`Val`) (select `ReportDate`,`DeviceID`,sum(`Val`) from `nccs`.`EnvDataTvoc` group by `ReportDate`,`DeviceID`) ;



-- 下面的内容走的是代码更新
/*

-- AlternateDate
delete from `nccs`.`AlternateDate` where SpecialDate in (select SpecialDate from (select SpecialDate, count(SpecialDate) as count, SchoolID from AlternateDate group by SpecialDate) as a where a.count >1) and SchoolID!=1;
ALTER TABLE `nccs`.`AlternateDate` DROP INDEX `schoolIndex`;
ALTER TABLE `nccs`.`AlternateDate` DROP COLUMN `SchoolID`;
DROP INDEX `date_school` ON `nccs`.`AlternateDate`;
ALTER TABLE `nccs`.`AlternateDate` ADD PRIMARY Key (`SpecialDate`);


-- BaseInfo 表处理
delete `nccs`.`BaseInfo` from `nccs`.`BaseInfo` inner join (select `InfomationID`,count from (select InfomationID, count(InfomationID) as count, SchoolID from BaseInfo group by InfomationID) as a where a.count >1) as b on `nccs`.`BaseInfo`.InfomationID=b.InfomationID where `nccs`.`BaseInfo`.SchoolID!=1;
ALTER TABLE `nccs`.`BaseInfo` DROP INDEX `index`;
ALTER TABLE `nccs`.`BaseInfo` ADD PRIMARY Key (`InfomationID`);
ALTER TABLE `nccs`.`BaseInfo` DROP COLUMN `SchoolID`;

-- BroadcastMode
ALTER TABLE `nccs`.`BroadcastMode` DROP INDEX `schoolIndex`;
ALTER TABLE `nccs`.`BroadcastMode` DROP COLUMN `SchoolID`;

-- DevClasses
ALTER TABLE `nccs`.`DevClasses` DROP INDEX `schoolIndex`;
ALTER TABLE `nccs`.`DevClasses` DROP COLUMN `SchoolID`;

-- DeviceList
ALTER TABLE `nccs`.`DeviceList` DROP COLUMN `SchoolID`;

-- DeviceLog
ALTER TABLE `nccs`.`DeviceLog` DROP INDEX `schoolTime`;
ALTER TABLE `nccs`.`DeviceLog` DROP COLUMN `SchoolID`;


-- DeviceStatistic
delete `nccs`.`DeviceStatistic` from `nccs`.`DeviceStatistic` inner join (select DeviceID,StatisticDay,count from (select DeviceID, StatisticDay, count(StatisticDay) as count, SchoolID from DeviceStatistic group by DeviceID, StatisticDay) as a where a.count >1) as b on `nccs`.`DeviceStatistic`.DeviceID=b.DeviceID and `nccs`.`DeviceStatistic`.StatisticDay=b.StatisticDay where `nccs`.`DeviceStatistic`.SchoolID!=1;
ALTER TABLE `nccs`.`DeviceStatistic` DROP PRIMARY Key;
ALTER TABLE `nccs`.`DeviceStatistic` ADD PRIMARY Key (`DeviceID`,`StatisticDay`);
ALTER TABLE `nccs`.`DeviceStatistic` DROP INDEX `schoolIndex`;
ALTER TABLE `nccs`.`DeviceStatistic` DROP COLUMN `SchoolID`;


-- DevicePower
ALTER TABLE `nccs`.`DevicePower` DROP INDEX `StatisticDay`;
ALTER TABLE `nccs`.`DevicePower` ADD UNIQUE Key `StatisticDay` (`StatisticDay`,`DeviceID`,`SubID`,`SubType`) USING BTREE;
ALTER TABLE `nccs`.`DevicePower` DROP COLUMN `SchoolID`;
-- 將今年最新表的SchoolID设置为默认为0，并且不用清除SchoolID字段
ALTER TABLE `nccs`.`DevicePower2022` MODIFY COLUMN SchoolID int(11) NOT NULL DEFAULT 0; 


-- DevStartingPic
delete from `nccs`.`DevStartingPic` where `Type` in (select `Type` from (select `Type`, count(`Type`) as count, SchoolID from DevStartingPic group by `Type`) as a where a.count >1) and SchoolID!=1;
ALTER TABLE `nccs`.`DevStartingPic` DROP PRIMARY Key;
ALTER TABLE `nccs`.`DevStartingPic` ADD PRIMARY Key (`Type`);
ALTER TABLE `nccs`.`DevStartingPic` DROP COLUMN `SchoolID`;


-- DoubleClass
ALTER TABLE `nccs`.`DoubleClass` DROP COLUMN `SchoolId`;

-- DoubleClassCourse
ALTER TABLE `nccs`.`DoubleClassCourse` DROP COLUMN `SchoolIds`;

*/






/*
-- Event
ALTER TABLE `nccs`.`Event` DROP INDEX `schoolIndex`;
ALTER TABLE `nccs`.`Event` DROP COLUMN `SchoolID`;

-- EventModel
ALTER TABLE `nccs`.`EventModel` DROP INDEX `schoolIndex`;
ALTER TABLE `nccs`.`EventModel` DROP COLUMN `SchoolID`;

-- Firmware
ALTER TABLE `nccs`.`Firmware` DROP INDEX `nameIndex`;
ALTER TABLE `nccs`.`Firmware` DROP COLUMN `school_id`;

-- Graphics
ALTER TABLE `nccs`.`Graphics` DROP COLUMN `SchoolID`;

-- GraphicSessions
ALTER TABLE `nccs`.`GraphicSessions` DROP COLUMN `school_id`;


-- LogicClasses
ALTER TABLE `nccs`.`LogicClasses` DROP INDEX `nameSchoolIndex`;
ALTER TABLE `nccs`.`LogicClasses` DROP COLUMN `school_id`;


-- MediaFiles
ALTER TABLE `nccs`.`MediaFiles` DROP INDEX `schoolIndex`;
ALTER TABLE `nccs`.`MediaFiles` DROP COLUMN `SchoolID`;


-- MicPhoneList
ALTER TABLE `nccs`.`MicPhoneList` DROP COLUMN `school_id`;

-- MicStubList
ALTER TABLE `nccs`.`MicStubList` DROP COLUMN `school_id`;

-- Players
ALTER TABLE `nccs`.`Players` DROP INDEX `schoolIndex`;
ALTER TABLE `nccs`.`Players` DROP COLUMN `SchoolID`;

-- PlayerStatus
ALTER TABLE `nccs`.`PlayerStatus` DROP INDEX `schoolIndex`;
ALTER TABLE `nccs`.`PlayerStatus` DROP COLUMN `SchoolID`;

-- PlaySessions
ALTER TABLE `nccs`.`PlaySessions` DROP INDEX `schoolIndex`;
ALTER TABLE `nccs`.`PlaySessions` DROP COLUMN `SchoolID`;


-- PwrDisplaySet
delete `nccs`.`PwrDisplaySet` from `nccs`.`PwrDisplaySet` inner join (select `PwrID`,`Name`,`Type`,`Icon`,count from (select PwrID,Name,`Type`,`Icon`, SchoolID,count(PwrID) as count from PwrDisplaySet group by PwrID) as a where a.count >1) as b on `nccs`.`PwrDisplaySet`.PwrID=b.PwrID where `nccs`.`PwrDisplaySet`.SchoolID!=1;
ALTER TABLE `nccs`.`PwrDisplaySet` DROP INDEX `schoolIndex`;
ALTER TABLE `nccs`.`PwrDisplaySet` DROP COLUMN `SchoolID`;


-- RegisterUser
ALTER TABLE `nccs`.`RegisterUser` DROP COLUMN `SchoolID`;
ALTER TABLE `nccs`.`RegisterUser` DROP COLUMN `MatchSchoolID`;


-- RfChildType
delete `nccs`.`RfChildType` from `nccs`.`RfChildType` inner join (select `RfType`,`Name`, count from (select `RfType`,`Name`,SchoolID, count(RfType) as count from RfChildType group by `Name`) as a where a.count >1) as b on `nccs`.`RfChildType`.Name=b.Name where `nccs`.`RfChildType`.SchoolID!=1;
ALTER TABLE `nccs`.`RfChildType` DROP INDEX `School_Name`;
ALTER TABLE `nccs`.`RfChildType` DROP COLUMN `SchoolID`;
ALTER TABLE `nccs`.`RfChildType` ADD UNIQUE KEY `rfName` (`Name`) USING BTREE;

-- SectionTable
delete `nccs`.`SectionTable` from `nccs`.`SectionTable` inner join (select `zone`,`name`, count from (select `zone`,`name`,SchoolID, count(`zone`) as count from SectionTable group by `Name`, `zone`) as a where a.count >1) as b on `nccs`.`SectionTable`.Name=b.Name and `nccs`.`SectionTable`.`zone`=b.`zone` where `nccs`.`SectionTable`.SchoolID!=1;
ALTER TABLE `nccs`.`SectionTable` DROP INDEX `SectionTableUnique`;
ALTER TABLE `nccs`.`SectionTable` DROP INDEX `schoolIndex`;
ALTER TABLE `nccs`.`SectionTable` DROP COLUMN `SchoolID`;
ALTER TABLE `nccs`.`SectionTable` ADD UNIQUE INDEX `SectionTableUnique` (`zone` ASC,`name` ASC) USING BTREE;



-- SessionHistory
delete `nccs`.`SessionHistory` from `nccs`.`SessionHistory` inner join (select `SessionID`,`ScheduleID`,`HistoryDate`,`ScheduleTime`, count from (select `SessionID`,`ScheduleID`,`HistoryDate`,`ScheduleTime`, count(`ScheduleTime`) as count from SessionHistory group by `SessionID`,`ScheduleID`,`HistoryDate`,`ScheduleTime`) as a where a.count >1) as b on `nccs`.`SessionHistory`.`SessionID`=b.`SessionID` and `nccs`.`SessionHistory`.`ScheduleID`=b.`ScheduleID` and `nccs`.`SessionHistory`.`HistoryDate`=b.`HistoryDate` and `nccs`.`SessionHistory`.`ScheduleTime`=b.`ScheduleTime` where `nccs`.`SessionHistory`.SchoolID!=1;
ALTER TABLE `nccs`.`SessionHistory` DROP INDEX `SessionID`;
ALTER TABLE `nccs`.`SessionHistory` DROP COLUMN `SchoolID`;
ALTER TABLE `nccs`.`SessionHistory` ADD UNIQUE KEY `SessionID` (`SessionID`,`ScheduleID`,`HistoryDate`,`ScheduleTime`) USING BTREE;




-- SubNetwork
ALTER TABLE `nccs`.`SubNetwork` DROP INDEX `schoolIndex`;
ALTER TABLE `nccs`.`SubNetwork` DROP COLUMN `SchoolID`;


-- SystemLog
ALTER TABLE `nccs`.`SystemLog` DROP INDEX `SchoolAt`;
ALTER TABLE `nccs`.`SystemLog` DROP COLUMN `SchoolID`;



-- TaskTemplate
ALTER TABLE `nccs`.`TaskTemplate` DROP INDEX `schoolIndex`;
ALTER TABLE `nccs`.`TaskTemplate` DROP COLUMN `SchoolID`;

-- Timetable
ALTER TABLE `nccs`.`Timetable` DROP INDEX `schoolIndex`;
ALTER TABLE `nccs`.`Timetable` DROP COLUMN `SchoolID`;




-- Users




ALTER TABLE `nccs`.`Users` DROP INDEX `IcCard_UNIQUE`;
ALTER TABLE `nccs`.`Users` ADD UNIQUE INDEX `IcCard_UNIQUE` USING BTREE (`IcCard`);

ALTER TABLE `nccs`.`Users` DROP INDEX `User_Sn_UNIQUE`;
ALTER TABLE `nccs`.`Users` ADD UNIQUE INDEX `User_Sn_UNIQUE` USING BTREE (`User_Sn`);


ALTER TABLE `nccs`.`Users` DROP INDEX `Phone_UNIQUE`;
ALTER TABLE `nccs`.`Users` ADD UNIQUE INDEX `Phone_UNIQUE` USING BTREE (`Phone`);

ALTER TABLE `nccs`.`Users` DROP INDEX `schoolIndex`;
ALTER TABLE `nccs`.`Users` DROP COLUMN `SchoolID`;
*/


-- D08.01.02
-- 添加协议设备类型字段
ALTER TABLE `nccs`.`DeviceList` ADD COLUMN `ProtocolDevName`  VARCHAR(16) DEFAULT '' COMMENT '协议设备类型';
ALTER TABLE `nccs`.`Players` ADD COLUMN `ProtocolDevName`  VARCHAR(16) DEFAULT '' COMMENT '协议设备类型';

-- BW805 音频通道配置
ALTER TABLE `nccs`.`Players` ADD COLUMN `AudioChannelConfig`  varchar(1024) NOT NULL DEFAULT '' COMMENT '音频通道配置';

-- BW805 采播场景
CREATE TABLE IF NOT EXISTS `nccs`.`PlayerScenes` (
                                                     `PlayerID` varchar(50) NOT NULL DEFAULT '' COMMENT '采播设备ID',
                                                     `SceneID` int(11) NOT NULL DEFAULT '1' COMMENT '采播设备场景ID',
                                                     `SceneName` varchar(96) NOT NULL DEFAULT '' COMMENT '场景名称（不能超过32个汉字）',
                                                     `SceneCtrlList` varchar(4096) NOT NULL DEFAULT '' COMMENT '场景控制列表，为json字符串',
                                                     PRIMARY KEY (`PlayerID`,`SceneID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;

-- BW805 逻辑分区增加分类列（采播设备按键对应的设备采用逻辑分区存储）
ALTER TABLE `nccs`.`LogicClasses` ADD COLUMN `type`  tinyint NOT NULL DEFAULT 1 COMMENT '类型 1-采播设备逻辑分区';

-- BW805 逻辑分区增加注释
ALTER TABLE `nccs`.`LogicClasses`
    MODIFY COLUMN `name`  varchar(256) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '逻辑分区名称（不重复 使用其他表数据生成的名称）' AFTER `id`,
    MODIFY COLUMN `extend_name`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '逻辑分区扩展名称（用于显示的名称）' AFTER `name`,
    COMMENT='设备逻辑分区';

ALTER TABLE `nccs`.`LogicClassDevices`
    MODIFY COLUMN `id`  int(11) NOT NULL AUTO_INCREMENT COMMENT 'ID' FIRST ,
    MODIFY COLUMN `class_id`  int(11) NOT NULL COMMENT '逻辑分区ID' AFTER `id`,
    MODIFY COLUMN `device`  varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '设备ID' AFTER `class_id`,
    COMMENT='逻辑分区设备';

-- 采播定时任务相关字段
ALTER TABLE `nccs`.`PlaySessionTime`
    ADD COLUMN `TaskType`  varchar(255) NOT NULL DEFAULT '' COMMENT '采播推流类型 video-视频推流   audio-音频推流' AFTER `Length`;
ALTER TABLE `nccs`.`PlaySessionTime`
    ADD COLUMN `AudioChannels`  varchar(255) NOT NULL DEFAULT '' COMMENT '采播开启音频通道（存储通道下标数组）' AFTER `TaskType`;
ALTER TABLE `nccs`.`PlaySessionTime`
    ADD COLUMN `LocalMedia`  varchar(4096) NOT NULL DEFAULT '' COMMENT '采播任务选择的设备媒体信息' AFTER `AudioChannels`;
ALTER TABLE `nccs`.`PlaySessionTime`
    ADD COLUMN `KeyZones`  varchar(255) NOT NULL DEFAULT '' COMMENT '801 805 定时任务按键分区' AFTER `LocalMedia`;


-- 去掉按键分区外键
ALTER TABLE `nccs`.`PlayerKeys` DROP FOREIGN KEY `PlayerLogicClassID`;
ALTER TABLE `nccs`.`PlayerKeys` DROP INDEX `PlayerLogicClassID`;

-- 去掉设备逻辑分区外键
ALTER TABLE `nccs`.`LogicClassDevices` DROP FOREIGN KEY `classForeignKey`;


-- D08.01.03
ALTER TABLE `nccs`.`Users` ADD COLUMN `SyncLockStartTime` datetime (0) NULL DEFAULT NULL COMMENT '用户锁定开始时间 yyyy:MM:dd HH:mm:ss' AFTER `UpdatePwdTime`;
ALTER TABLE `nccs`.`Users` ADD COLUMN `SyncLockEndTime` datetime (0) NULL DEFAULT NULL COMMENT '用户锁定结束时间 yyyy:MM:dd HH:mm:ss' AFTER `SyncLockStartTime`;

ALTER TABLE `nccs`.`SubNetwork` ADD COLUMN `UniCast` TINYINT(4) NOT NULL DEFAULT 0 AFTER `IpAddress`;


-- D08.01.04
-- 修改文件名称长度
ALTER TABLE `nccs`.`MediaFiles` MODIFY COLUMN `FileName` VARCHAR (128);

-- IC卡同步到设备
CREATE TABLE IF NOT EXISTS `nccs`.`UserIcCardSync` (
   `DevID` varchar(255) NOT NULL DEFAULT '' COMMENT '设备ID',
   `OnlineTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '上线时间',
   `SyncValue` bigint(20) NOT NULL DEFAULT '-1' COMMENT '同步字',
   `SyncNum` int(11) NOT NULL DEFAULT '0' COMMENT '同步数量',
   `SyncIcData` varchar(4096) NOT NULL DEFAULT '' COMMENT '同步IC卡数据（用于调试）',
   `SyncTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '同步时间',
   `SyncCount` int(11) NOT NULL DEFAULT '0' COMMENT '同步总次数',
   `UpdateSyncValue` bigint(20) NOT NULL DEFAULT '-1' COMMENT '更新的同步字',
   `UpdateSyncNum` int(11) NOT NULL DEFAULT '0' COMMENT '更新的同步数量',
   `UpdateSyncTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '更新的同步时间',
   `UpdateCount` int(11) NOT NULL DEFAULT '0' COMMENT '更新的总次数',
   PRIMARY KEY (`DevID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='用户IC卡数据同步给设备';



-- D08.01.06
-- 如遇失败 执行 UPDATE  Users u LEFT JOIN  (SELECT trim( LEADING '0' FROM IcCard ) as ic,SchoolID,max(User_ID) as max_user_id  FROM Users GROUP BY ic,SchoolID HAVING COUNT(1)>1) as u2 on(  u2.ic=trim( LEADING '0' FROM u.IcCard ) and u.SchoolID=u2.SchoolID) Set u.IcCard=CONCAT(trim( LEADING '0' FROM IcCard ),(CASE WHEN (u.User_ID=u2.max_user_id OR u2.ic is null) THEN '' ELSE u.User_ID END));
-- 去掉IC卡号前面的0
UPDATE Users SET ICCard = REPLACE(LTRIM(REPLACE(ICCard, 0, ' ')), ' ', 0);


ALTER TABLE `nccs`.`BroadcastMode` ADD COLUMN `ReceivingEndType` int(11) NOT NULL DEFAULT 0 COMMENT '0:设备，1：空间 ，2：分组' AFTER `StopEntryID`;



ALTER TABLE `nccs`.`EnvControlInfo` ADD COLUMN `ReceivingEndType` int(10) NOT NULL DEFAULT 0 COMMENT '0: 设备 1：空间，2：分组' AFTER `TimeSpot`;


ALTER TABLE `nccs`.`GraphicSessions` ADD COLUMN `receiving_end_type` int(11) NOT NULL DEFAULT 0 AFTER `update_status_time`;



CREATE TABLE IF NOT EXISTS `nccs`.`Monitor`  (
     `id` int(11) NOT NULL AUTO_INCREMENT,
     `space_id` int(11) NOT NULL DEFAULT 0,
     `url` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '主码流',
     `sub_url` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '副码流',
     `update_time` datetime(0) NOT NULL DEFAULT CURRENT_TIMESTAMP(0) ON UPDATE CURRENT_TIMESTAMP(0),
     `create_time` datetime(0) NOT NULL DEFAULT CURRENT_TIMESTAMP(0),
     PRIMARY KEY (`id`) USING BTREE,
     INDEX `space_id`(`space_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '监控' ROW_FORMAT = Dynamic;



ALTER TABLE `nccs`.`PlaySessions` ADD COLUMN `ReceivingEndType` int(11) NOT NULL DEFAULT 0 COMMENT '0: 设备 1：空间，2：分组' AFTER `Template`;

CREATE TABLE IF NOT EXISTS `nccs`.`RemotePC`  (
      `id` int(11) NOT NULL AUTO_INCREMENT,
      `ip` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
      `ctrl_pwd` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
      `view_pwd` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
      `port` int(255) NOT NULL DEFAULT 0,
      `space_id` int(11) NOT NULL,
      `update_time` datetime(0) NOT NULL DEFAULT CURRENT_TIMESTAMP(0) ON UPDATE CURRENT_TIMESTAMP(0),
      `create_time` datetime(0) NOT NULL DEFAULT CURRENT_TIMESTAMP(0),
      PRIMARY KEY (`id`) USING BTREE,
      INDEX `space_id`(`space_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '远程电脑控制' ROW_FORMAT = Dynamic;


CREATE TABLE IF NOT EXISTS `nccs`.`Space`  (
   `id` int(11) NOT NULL AUTO_INCREMENT,
   `name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '空间名称',
   `update_time` datetime(0) NOT NULL DEFAULT CURRENT_TIMESTAMP(0) ON UPDATE CURRENT_TIMESTAMP(0),
   `create_time` datetime(0) NOT NULL DEFAULT CURRENT_TIMESTAMP(0),
   PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '空间表' ROW_FORMAT = Dynamic;

CREATE TABLE IF NOT EXISTS `nccs`.`SpaceAndDevice`  (
    `space_id` int(11) NOT NULL COMMENT '空间ID',
    `dev_id` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备ID',
    `is_master` tinyint(1) NOT NULL DEFAULT 0 COMMENT '0:从设备，1：主设备',
    `enable_audio` tinyint(1) NOT NULL DEFAULT 0 COMMENT '0:禁用，1：启用',
    `enable_video` tinyint(1) NOT NULL DEFAULT 0 COMMENT '0:禁用，1：启用',
    `enable_rf` tinyint(1) NOT NULL DEFAULT 1 COMMENT '0:禁用，1：启用 默认启用 ',
    `update_time` datetime(0) NOT NULL DEFAULT CURRENT_TIMESTAMP(0) ON UPDATE CURRENT_TIMESTAMP(0),
    `create_time` datetime(0) NOT NULL DEFAULT CURRENT_TIMESTAMP(0),
    UNIQUE INDEX `space_id`(`space_id`, `dev_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;


ALTER TABLE `nccs`.`Users` ADD COLUMN `UseReceivingEndType` int(11) NOT NULL DEFAULT 0 AFTER `SyncLockEndTime`;

ALTER TABLE `nccs`.`Users` ADD COLUMN `MgrReceivingEndType` int(11) NOT NULL DEFAULT 0 AFTER `UseReceivingEndType`;

-- 音频媒体编码设置为MP3
UPDATE `MediaFiles` SET `AudioCodec` = 1 WHERE `AudioCodec` = 0 AND `VedioCodec` = -1;

-- 今日任务区分PC呼叫台和BW801
ALTER TABLE `SessionHistory` ADD COLUMN `PlayerID`  varchar(50) NOT NULL DEFAULT '' COMMENT '采播设备ID' AFTER `HistoryDate`;

-- 初始化用户 设备权限

UPDATE Users SET UseReceivingEndType=1,MgrReceivingEndType=1;


-- D08.01.07
-- 双师课堂 课堂教室（空间）
CREATE TABLE IF NOT EXISTS `DoubleClassSpace` (
      `SpaceID` int(11) NOT NULL DEFAULT '0' COMMENT '教室（空间）ID',
      `DeviceMain` varchar(255) NOT NULL DEFAULT '' COMMENT '主设备ID',
      `DeviceSlave` varchar(255) NOT NULL DEFAULT '' COMMENT '辅设备ID',
      `CreateTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '创建时间',
      PRIMARY KEY (`SpaceID`),
      UNIQUE KEY `devices` (`DeviceMain`,`DeviceSlave`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='双师课堂教室（空间）';

-- 双师课堂 课堂设备增加教室（空间）
ALTER TABLE `DoubleClassDevice`
    ADD COLUMN `SpaceID`  int NOT NULL DEFAULT 0 COMMENT '教室（空间）ID' AFTER `ClassId`;

-- 双师课堂 课程设备增加教室（空间）
ALTER TABLE `DoubleClassCourseDevice`
    ADD COLUMN `SpaceID`  int NOT NULL DEFAULT 0 COMMENT '教室（空间）ID' AFTER `CourseId`,
    ADD COLUMN `SpaceName`  varchar(255) NOT NULL DEFAULT '' COMMENT '教室（空间）名称' AFTER `SpaceID`;


-- D08.01.08

-- 投影仪和预览信号源通道
CREATE TABLE IF NOT EXISTS `SignalSourceChannel`(
    `id`                int(11) NOT NULL AUTO_INCREMENT,
    `space_id`          int(11) NOT NULL DEFAULT 0 COMMENT '空间id',
    `projector_channel` varchar(512) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '投影仪通道',
    `preview_channel`   varchar(512) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '预览通道',
    `update_time`       datetime                                                NOT NULL DEFAULT CURRENT_TIMESTAMP(0) ON UPDATE CURRENT_TIMESTAMP (0),
    `create_time`       datetime                                                NOT NULL DEFAULT CURRENT_TIMESTAMP(0),
    PRIMARY KEY (`id`) USING BTREE,
    INDEX               `space_id` (`space_id`) USING BTREE
) ENGINE = InnoDB CHARSET = utf8 COLLATE = utf8_general_ci COMMENT ='投影仪和预览信号源通道配置表' ROW_FORMAT = Dynamic;


CREATE TABLE IF NOT EXISTS `nccs`.`BrdModeAndPartitionNode`  (
     `id` int(11) NOT NULL AUTO_INCREMENT,
     `brd_mode_id` int(11) NOT NULL COMMENT '模式ID',
     `partition_id` int(11) NOT NULL COMMENT '逻辑分区ID',
     PRIMARY KEY (`id`) USING BTREE,
     UNIQUE INDEX `logical_partition_id`(`partition_id`, `brd_mode_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '模式接收成员空间表' ROW_FORMAT = DYNAMIC;

CREATE TABLE IF NOT EXISTS `nccs`.`EnvControlAndPartitionNode`  (
        `id` int(11) NOT NULL AUTO_INCREMENT,
        `env_ctrl_info_id` int(11) NOT NULL COMMENT '环境策略ID',
        `partition_id` int(11) NOT NULL COMMENT '逻辑分区ID',
        PRIMARY KEY (`id`) USING BTREE,
        UNIQUE INDEX `logical_partition_id`(`partition_id`, `env_ctrl_info_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '模式接收成员空间表' ROW_FORMAT = DYNAMIC;

CREATE TABLE IF NOT EXISTS `nccs`.`GraphicAndPartitionNode`  (
         `id` int(11) NOT NULL AUTO_INCREMENT,
         `session_id` int(11) NOT NULL,
         `partition_id` int(11) NOT NULL,
         PRIMARY KEY (`id`) USING BTREE,
         UNIQUE INDEX `session_id`(`session_id`, `partition_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '图文任务空间表' ROW_FORMAT = DYNAMIC;

CREATE TABLE IF NOT EXISTS `nccs`.`Partition`  (
       `id` int(11) NOT NULL AUTO_INCREMENT,
       `name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
       `type` tinyint(1) NOT NULL COMMENT '是否为物理分区：0：逻辑分区，1：物理分区',
       `update_time` datetime(0) NOT NULL DEFAULT CURRENT_TIMESTAMP(0) ON UPDATE CURRENT_TIMESTAMP(0),
       `create_time` datetime(0) NOT NULL DEFAULT CURRENT_TIMESTAMP(0),
       `is_deleted` tinyint(1) NOT NULL DEFAULT 0,
       PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '逻辑分区组' ROW_FORMAT = DYNAMIC;

CREATE TABLE IF NOT EXISTS `nccs`.`PartitionNode`  (
       `id` int(11) NOT NULL AUTO_INCREMENT,
       `p_id` int(11) NOT NULL DEFAULT 0,
       `name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
       `partition_id` int(11) NOT NULL DEFAULT 0,
       `space_id` int(11) NOT NULL DEFAULT 0 COMMENT '空间ID',
       `order_number` int(11) NOT NULL DEFAULT 0,
       `update_time` datetime(0) NOT NULL DEFAULT CURRENT_TIMESTAMP(0) ON UPDATE CURRENT_TIMESTAMP(0),
       `create_time` datetime(0) NOT NULL DEFAULT CURRENT_TIMESTAMP(0),
       PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '逻辑分区' ROW_FORMAT = DYNAMIC;

CREATE TABLE IF NOT EXISTS `nccs`.`SessionAndPartitionNode`  (
     `id` int(11) NOT NULL AUTO_INCREMENT,
     `session_id` int(11) NOT NULL,
     `partition_id` int(11) NOT NULL,
     PRIMARY KEY (`id`) USING BTREE,
     UNIQUE INDEX `session_id`(`session_id`, `partition_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '任务空间表' ROW_FORMAT = DYNAMIC;

CREATE TABLE IF NOT EXISTS `nccs`.`UserAndPartitionNode` (
     `id` int(11) NOT NULL AUTO_INCREMENT,
     `user_id` int(11) NOT NULL,
     `partition_id` int(11) NOT NULL,
     `pri` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'bit0: 用户可以使用的设备\\nbit1: 用户可以管理的设备',
     PRIMARY KEY (`id`) USING BTREE,
     UNIQUE KEY `session_id` (`user_id`,`partition_id`) USING BTREE
) ENGINE=InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '用户分区表' ROW_FORMAT = DYNAMIC;

ALTER TABLE `nccs`.`Space` ADD COLUMN `play_audio` tinyint(1) NOT NULL DEFAULT 0 COMMENT '能否播放音频' AFTER `name`;

ALTER TABLE `nccs`.`Space` ADD COLUMN `play_video` tinyint(1) NOT NULL DEFAULT 0 COMMENT '能否播放视频' AFTER `play_audio`;

ALTER TABLE `nccs`.`Space` ADD COLUMN `play_graphic` tinyint(1) NOT NULL DEFAULT 0 COMMENT ' 能否播放图文' AFTER `play_video`;

ALTER TABLE `nccs`.`Space` ADD COLUMN `ctrl_rf` tinyint(1) NOT NULL DEFAULT 0 COMMENT '能否控制物联' AFTER `play_graphic`;

ALTER TABLE `nccs`.`Space` ADD COLUMN `master_dev_id` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '主设备ID' AFTER `ctrl_rf`;

ALTER TABLE `nccs`.`Space` ADD COLUMN `is_deleted` tinyint(1) NOT NULL DEFAULT 0 COMMENT '是否已删除' AFTER `master_dev_id`;

ALTER TABLE `nccs`.`SpaceAndDevice` MODIFY COLUMN `dev_id` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备ID' FIRST;

ALTER TABLE `nccs`.`SpaceAndDevice` MODIFY COLUMN `enable_rf` tinyint(1) NOT NULL DEFAULT 1 COMMENT '0:禁用，1：启用 默认启用' AFTER `enable_video`;

ALTER TABLE `nccs`.`SpaceAndDevice` ADD PRIMARY KEY (`dev_id`) USING BTREE;

ALTER TABLE `nccs`.`SpaceAndDevice` DROP COLUMN `is_master`;




DELETE FROM SpaceAndDevice ;

DELETE FROM Space;

-- 1、初始化物理分区根节点
DELETE FROM `Partition`;

DELETE FROM PartitionNode;

INSERT INTO `Partition`(`name`,type) VALUES('默认分区组',0);

-- 2、初始化空间表

INSERT INTO Space(`name`,master_dev_id) SELECT  d.Dev_Name,d.DevID FROM DeviceList d where d.Dev_Name is not null;

-- 初始化分区
INSERT INTO PartitionNode(id,`name`,p_id,space_id) SELECT ClassID,`Name`,IFNULL(Parent,0),0 FROM DevClasses  UNION ALL  SELECT NULL,d.Dev_Name as Name,d.Parent,s.id  FROM DeviceList d INNER JOIN Space s on s.master_dev_id=d.DevID  WHERE d.Parent is not null;

update PartitionNode set partition_id= (SELECT id FROM `Partition` LIMIT 1);
-- 3、初始化空间设备基本属性表

INSERT INTO SpaceAndDevice(space_id,dev_id,enable_audio,enable_video) SELECT s.id,d.DevID,1,1 FROM Space s INNER  JOIN DeviceList d on s.master_dev_id=d.DevID;

-- 4、初始化用户 设备权限

UPDATE Users SET UseReceivingEndType=1,MgrReceivingEndType=1;

INSERT INTO UserAndPartitionNode(user_id,partition_id,pri) SELECT ud.UserID,pn.id,ud.Pri FROM  UserDevices ud INNER JOIN SpaceAndDevice sd on sd.dev_id=ud.DevID INNER JOIN PartitionNode pn on pn.space_id=sd.space_id;

-- 5、投影仪通道数据迁移
INSERT IGNORE INTO `SignalSourceChannel` (
    `space_id`,
    `projector_channel`,
    `preview_channel`
)(
    SELECT sp.id, proj.projector_channel, prev.preview_channel FROM `Space` sp
                                                                        LEFT JOIN (SELECT IFNULL(a.Description, '') AS projector_channel FROM `BaseInfo` a WHERE a.InfomationID = 401) AS proj ON TRUE
                                                                        LEFT JOIN (SELECT IFNULL(b.Description, '') AS preview_channel FROM `BaseInfo` b WHERE b.InfomationID = 402 ) AS prev ON TRUE
);


-- BW805只有15个分区
DELETE FROM `LogicClassDevices` WHERE `class_id` IN (SELECT `logic_class_id` FROM `PlayerKeys` WHERE `Index` >=  15);
DELETE FROM `LogicClasses` WHERE `id` IN (SELECT `logic_class_id` FROM `PlayerKeys` WHERE `Index` >=  15);
DELETE FROM  `PlayerKeys` WHERE `Index` >=  15;

-- BW801只有10个分区 从1-10 6.8版本就是1-10
DELETE FROM `LogicClassDevices` WHERE `class_id` IN (SELECT `logic_class_id` FROM `PlayerKeys` WHERE `Index` >  10 and left(PlayerID,2)='30');
DELETE FROM `LogicClasses` WHERE `id` IN (SELECT `logic_class_id` FROM `PlayerKeys` WHERE `Index` >  15 and left(PlayerID,2)='30');
DELETE FROM  `PlayerKeys` WHERE `Index` >  10 and left(PlayerID,2)='30';

-- 第三方二维码
ALTER TABLE `nccs`.`ThirdClassDevices` ADD COLUMN `qrcode` varchar(512) NOT NULL DEFAULT '' COMMENT '第三方二维码' AFTER `app_id`;


-- D08.01.09

ALTER TABLE `nccs`.`Users` MODIFY COLUMN `UseReceivingEndType` int(11) NOT NULL DEFAULT 1 AFTER `SyncLockEndTime`;

ALTER TABLE `nccs`.`Users` MODIFY COLUMN `MgrReceivingEndType` int(11)  NOT NULL DEFAULT 1 AFTER `UseReceivingEndType`;


DELETE FROM Monitor;

DELETE FROM RemotePC;

INSERT INTO Monitor(space_id,url,sub_url) SELECT s.id,d.RtspUrl,IFNULL(d.RtspSub,"") FROM SpaceAndDevice sd INNER JOIN Space s on s.id=sd.space_id and  s.master_dev_id=sd.dev_id INNER JOIN DeviceList d on d.DevID=sd.dev_id WHERE d.RtspUrl is NOT NULL and d.RtspUrl!="" ;

INSERT INTO Monitor(space_id,url,sub_url) SELECT s.id,d.RtspUrl1,IFNULL(d.RtspSub1,"") FROM SpaceAndDevice sd INNER JOIN Space s on s.id=sd.space_id and  s.master_dev_id=sd.dev_id INNER JOIN DeviceList d on d.DevID=sd.dev_id WHERE d.RtspUrl1 is NOT NULL and d.RtspUrl1!="" ;

INSERT INTO RemotePC(ip,ctrl_pwd,view_pwd,`port`,space_id) SELECT  d.PcIp,IFNULL(d.PcMainPasswd,""),IFNULL(d.PcViewPasswd,""),IFNULL(d.PcPort,0),s.id FROM SpaceAndDevice sd INNER JOIN Space s on s.id=sd.space_id and  s.master_dev_id=sd.dev_id INNER JOIN DeviceList d on d.DevID=sd.dev_id WHERE d.PcIp is NOT NULL and d.PcIp!="" ;


SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;