-- MySQL Workbench Synchronization
-- Generated: 2022-11-11 14:44:57
-- Model: nccs
-- Version: D08.01.04
-- Project: idsteServers
-- Author:

SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL,ALLOW_INVALID_DATES';

-- D08.03.01
CREATE TABLE IF NOT EXISTS `nccs`.`CLKMode`  (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `name` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '电子时钟任务名称',
  `start_time` datetime(0) NOT NULL COMMENT '模式开始时间',
  `start_entry_id` int(11) NOT NULL DEFAULT 0 COMMENT '模式开始时间在cron中的entry id',
  `end_time` datetime(0) NOT NULL COMMENT '模式结束时间。以unix时间戳形式下发。type=0时，该值为0；type=3时，是考试的结束时间；type=1或者type=2时，表示模式结束的绝对时间。',
  `end_entry_id` int(11) NOT NULL DEFAULT 0 COMMENT '模式结束时间在cron中的entry id',
  `priority` int(11) NOT NULL COMMENT '任务优先级',
  `mode_array` json NOT NULL COMMENT '电子时钟模式,一个数组，json格式。每个元素包含了电子时钟id，电子时钟的模式(0：普通模式，显示年月日时分秒 1：中考模式，显示”距离中考还有xx天” 2：高考模式，显示“距离高考还有xx天” 3：普通考试模式，显示”距离考试结束还有xx分钟”)。',
  `receive_member_type` int(11) NOT NULL COMMENT '任务接收成员类型',
  `owner` int(11) NOT NULL COMMENT '所属用户                                                         ',
  `update_at` datetime(0) NOT NULL DEFAULT CURRENT_TIMESTAMP(0) ON UPDATE CURRENT_TIMESTAMP(0) COMMENT '更新该条数据的时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;


CREATE TABLE IF NOT EXISTS `nccs`.`CLKModeMember`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `mode_id` int(11) NOT NULL COMMENT '模式id',
  `partition_id` int(11) NOT NULL COMMENT '空间或者分组id',
  `update_at` datetime(0) NOT NULL DEFAULT CURRENT_TIMESTAMP(0) ON UPDATE CURRENT_TIMESTAMP(0),
  PRIMARY KEY (`id`) USING BTREE,
  UNIQUE INDEX `taskid_memberid`(`partition_id`, `mode_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;


-- D08.03.02
-- 更新老中控类型
UPDATE Firmware SET pre = 'ncxx,bc02,bc03,bc04' WHERE pre = 'ncxx,bc02,bc03';

-- D08.03.03
INSERT INTO ReportData(table_id,row_id,header_column_id,base_id,val) SELECT * FROM (SELECT table_id,row_id,header_column_id,CONCAT('temp',s.id) as base_id,SUM(val) as val FROM ReportData r INNER JOIN Space s on s.master_dev_id=RIGHT(base_id,10) and s.is_deleted=0    GROUP BY table_id,row_id,header_column_id,RIGHT(base_id,10)) as a;
DELETE FROM ReportData WHERE LEFT(base_id,4)!='temp';
UPDATE  ReportData SET base_id=SUBSTRING(base_id,5);

ALTER TABLE `nccs`.`CLKMode` MODIFY COLUMN `receive_member_type` int(11) NOT NULL DEFAULT 1 COMMENT '任务接收成员类型' AFTER `mode_array`;

ALTER TABLE `nccs`.`DeviceReserve` ADD COLUMN `SpaceID` int(11) NOT NULL AFTER `ClassName`;

ALTER TABLE `nccs`.`DeviceReserveHistory` ADD COLUMN `SpaceID` int(11) NOT NULL AFTER `ClassName`;

ALTER TABLE `nccs`.`DeviceReserve` MODIFY COLUMN `DeviceID` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '设备ID' AFTER `SpaceID`;

ALTER TABLE `nccs`.`EnvControlInfo` MODIFY COLUMN `ReceivingEndType` int(10) NOT NULL DEFAULT 1 COMMENT '0: 设备 1：空间，2：分组' AFTER `TimeSpot`;

ALTER TABLE `nccs`.`GraphicSessions` MODIFY COLUMN `receiving_end_type` int(11) NOT NULL DEFAULT 1 AFTER `update_status_time`;

ALTER TABLE `nccs`.`PartitionNode` ADD COLUMN `node_type` int(11) NOT NULL DEFAULT 0 AFTER `name`;

ALTER TABLE `nccs`.`PlaySessions` MODIFY COLUMN `ReceivingEndType` int(11) NOT NULL DEFAULT 1 COMMENT '0: 设备 1：空间，2：分组' AFTER `Template`;

ALTER TABLE `nccs`.`SessionAndPartitionNode` ADD COLUMN `key_index` int(11) NOT NULL DEFAULT 0 AFTER `partition_id`;

ALTER TABLE `nccs`.`SessionAndPartitionNode` ADD COLUMN `node_disabled` int(11) NOT NULL DEFAULT 0 AFTER `key_index`;

ALTER TABLE `nccs`.`BroadcastMode` MODIFY COLUMN `ReceivingEndType` int(11) NOT NULL DEFAULT 1 COMMENT '0: 设备 1：空间，2：分组' AFTER `StopEntryID`;


update  CLKMode set receive_member_type=1 where receive_member_type=0;

update  BroadcastMode set ReceivingEndType=1 where ReceivingEndType=0;

update  EnvControlInfo set ReceivingEndType=1 where ReceivingEndType=0;

update  GraphicSessions set receiving_end_type=1 where receiving_end_type=0;

update PlaySessions set  ReceivingEndType=1 where ReceivingEndType=0;


insert into BrdModeAndPartitionNode(brd_mode_id, partition_id) SELECT DISTINCT b.BrdModeID,pn.id from BrdModeMember b inner join SpaceAndDevice sd on b.DeviceID=sd.dev_id inner join PartitionNode pn on sd.space_id = pn.space_id inner join `Partition` p on (sd.space_id = pn.space_id  and p.is_deleted=0) on duplicate key update brd_mode_id=values(brd_mode_id),partition_id=values(BrdModeAndPartitionNode.partition_id);

insert into EnvControlAndPartitionNode(env_ctrl_info_id, partition_id) SELECT DISTINCT b.`EnvCtrlInfoID`,pn.id from EnvControlDevices b inner join SpaceAndDevice sd on b.DeviceID=sd.dev_id inner join PartitionNode pn on sd.space_id = pn.space_id inner join `Partition` p on (sd.space_id = pn.space_id  and p.is_deleted=0) on duplicate key update env_ctrl_info_id=values(env_ctrl_info_id),partition_id=values(EnvControlAndPartitionNode.partition_id);

insert into GraphicAndPartitionNode(session_id, partition_id) SELECT DISTINCT b.`session`,pn.id from GraphicSessionMember b inner join SpaceAndDevice sd on b.device=sd.dev_id inner join PartitionNode pn on sd.space_id = pn.space_id inner join `Partition` p on (sd.space_id = pn.space_id  and p.is_deleted=0) on duplicate key update session_id=values(session_id),partition_id=values(GraphicAndPartitionNode.partition_id);

insert into SessionAndPartitionNode(session_id, partition_id,SessionAndPartitionNode.key_index,node_disabled) SELECT DISTINCT b.SessionID,pn.id,b.KeyIndex,b.DevDisabled from SessionDevice b inner join SpaceAndDevice sd on b.DeviceID=sd.dev_id inner join PartitionNode pn on sd.space_id = pn.space_id inner join `Partition` p on (sd.space_id = pn.space_id  and p.is_deleted=0) on duplicate key update session_id=values(session_id),partition_id=values(SessionAndPartitionNode.partition_id);



ALTER TABLE `nccs`.`Space` ADD COLUMN `location` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '空间位置' AFTER `id`;

ALTER TABLE `nccs`.`Space` ADD COLUMN `space_type` int(11) NOT NULL DEFAULT 0 AFTER `name`;

ALTER TABLE `nccs`.`Space` ADD COLUMN `class_type` int(11) NOT NULL DEFAULT 0 AFTER `space_type`;



ALTER TABLE `nccs`.`EnvDataCh2oV2` DROP INDEX `INDEX`;

ALTER TABLE `nccs`.`EnvDataCh2oV2` MODIFY COLUMN `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '设备ID' AFTER `ReportDate`;

ALTER TABLE `nccs`.`EnvDataCh2oV2` ADD COLUMN `SpaceID` int(11) NOT NULL DEFAULT '0' AFTER `Val`;

UPDATE EnvDataCh2oV2 as e,SpaceAndDevice as sp SET e.SpaceID=sp.space_id WHERE e.DeviceID=sp.dev_id;
delete from EnvDataCh2oV2  where EnvDataCh2oV2.SpaceID=0;

DELETE EnvDataCh2oV2  FROM EnvDataCh2oV2  INNER JOIN (SELECT min(id) as ID,ReportDate,SpaceID  FROM EnvDataCh2oV2 GROUP BY ReportDate,SpaceID HAVING Count(1)>1) as b on (EnvDataCh2oV2.SpaceID=b.SpaceID and EnvDataCh2oV2.ReportDate=b.ReportDate and EnvDataCh2oV2.id >b.ID);

ALTER TABLE `nccs`.`EnvDataCh2oV2` ADD UNIQUE INDEX `INDEX`(`ReportDate`, `SpaceID`) USING BTREE;





ALTER TABLE `nccs`.`EnvDataCo2V2` DROP INDEX `INDEX`;

ALTER TABLE `nccs`.`EnvDataCo2V2` MODIFY COLUMN `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '设备ID' AFTER `ReportDate`;

ALTER TABLE `nccs`.`EnvDataCo2V2` ADD COLUMN `SpaceID` int(11) NOT NULL DEFAULT '0' AFTER `Val`;

UPDATE EnvDataCo2V2 as e,SpaceAndDevice as sp SET e.SpaceID=sp.space_id WHERE e.DeviceID=sp.dev_id;
delete from EnvDataCo2V2  where EnvDataCo2V2.SpaceID=0;

DELETE EnvDataCo2V2  FROM EnvDataCo2V2  INNER JOIN (SELECT min(id) as ID,ReportDate,SpaceID  FROM EnvDataCo2V2 GROUP BY ReportDate,SpaceID HAVING Count(1)>1) as b on (EnvDataCo2V2.SpaceID=b.SpaceID and EnvDataCo2V2.ReportDate=b.ReportDate and EnvDataCo2V2.id >b.ID);

ALTER TABLE `nccs`.`EnvDataCo2V2` ADD UNIQUE INDEX `INDEX`(`ReportDate`, `SpaceID`) USING BTREE;



ALTER TABLE `nccs`.`EnvDataHumidityV2` DROP INDEX `INDEX`;

ALTER TABLE `nccs`.`EnvDataHumidityV2` MODIFY COLUMN `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '设备ID' AFTER `ReportDate`;

ALTER TABLE `nccs`.`EnvDataHumidityV2` ADD COLUMN `SpaceID` int(11) NOT NULL DEFAULT '0' AFTER `Val`;

UPDATE EnvDataHumidityV2 as e,SpaceAndDevice as sp SET e.SpaceID=sp.space_id WHERE e.DeviceID=sp.dev_id;
delete from EnvDataHumidityV2  where EnvDataHumidityV2.SpaceID=0;

DELETE EnvDataHumidityV2  FROM EnvDataHumidityV2  INNER JOIN (SELECT min(id) as ID,ReportDate,SpaceID  FROM EnvDataHumidityV2 GROUP BY ReportDate,SpaceID HAVING Count(1)>1) as b on (EnvDataHumidityV2.SpaceID=b.SpaceID and EnvDataHumidityV2.ReportDate=b.ReportDate and EnvDataHumidityV2.id >b.ID);

ALTER TABLE `nccs`.`EnvDataHumidityV2` ADD UNIQUE INDEX `INDEX`(`ReportDate`, `SpaceID`) USING BTREE;



ALTER TABLE `nccs`.`EnvDataInfraredV2` DROP INDEX `INDEX`;

ALTER TABLE `nccs`.`EnvDataInfraredV2` MODIFY COLUMN `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '设备ID' AFTER `ReportDate`;

ALTER TABLE `nccs`.`EnvDataInfraredV2` ADD COLUMN `SpaceID` int(11) NOT NULL DEFAULT '0' AFTER `Val`;

UPDATE EnvDataInfraredV2 as e,SpaceAndDevice as sp SET e.SpaceID=sp.space_id WHERE e.DeviceID=sp.dev_id;
delete from EnvDataInfraredV2  where EnvDataInfraredV2.SpaceID=0;

DELETE EnvDataInfraredV2  FROM EnvDataInfraredV2  INNER JOIN (SELECT min(id) as ID,ReportDate,SpaceID  FROM EnvDataInfraredV2 GROUP BY ReportDate,SpaceID HAVING Count(1)>1) as b on (EnvDataInfraredV2.SpaceID=b.SpaceID and EnvDataInfraredV2.ReportDate=b.ReportDate and EnvDataInfraredV2.id >b.ID);

ALTER TABLE `nccs`.`EnvDataInfraredV2` ADD UNIQUE INDEX `INDEX`(`ReportDate`, `SpaceID`) USING BTREE;




ALTER TABLE `nccs`.`EnvDataLightV2` DROP INDEX `INDEX`;

ALTER TABLE `nccs`.`EnvDataLightV2` MODIFY COLUMN `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '设备ID' AFTER `ReportDate`;

ALTER TABLE `nccs`.`EnvDataLightV2` ADD COLUMN `SpaceID` int(11) NOT NULL DEFAULT '0' AFTER `Val`;

UPDATE EnvDataLightV2 as e,SpaceAndDevice as sp SET e.SpaceID=sp.space_id WHERE e.DeviceID=sp.dev_id;
delete from EnvDataLightV2  where EnvDataLightV2.SpaceID=0;

DELETE EnvDataLightV2  FROM EnvDataLightV2  INNER JOIN (SELECT min(id) as ID,ReportDate,SpaceID  FROM EnvDataLightV2 GROUP BY ReportDate,SpaceID HAVING Count(1)>1) as b on (EnvDataLightV2.SpaceID=b.SpaceID and EnvDataLightV2.ReportDate=b.ReportDate and EnvDataLightV2.id >b.ID);

ALTER TABLE `nccs`.`EnvDataLightV2` ADD UNIQUE INDEX `INDEX`(`ReportDate`, `SpaceID`) USING BTREE;



ALTER TABLE `nccs`.`EnvDataNoiseV2` DROP INDEX `INDEX`;

ALTER TABLE `nccs`.`EnvDataNoiseV2` MODIFY COLUMN `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '设备ID' AFTER `ReportDate`;

ALTER TABLE `nccs`.`EnvDataNoiseV2` ADD COLUMN `SpaceID` int(11) NOT NULL DEFAULT '0' AFTER `Val`;

UPDATE EnvDataNoiseV2 as e,SpaceAndDevice as sp SET e.SpaceID=sp.space_id WHERE e.DeviceID=sp.dev_id;
delete from EnvDataNoiseV2  where EnvDataNoiseV2.SpaceID=0;

DELETE EnvDataNoiseV2  FROM EnvDataNoiseV2  INNER JOIN (SELECT min(id) as ID,ReportDate,SpaceID  FROM EnvDataNoiseV2 GROUP BY ReportDate,SpaceID HAVING Count(1)>1) as b on (EnvDataNoiseV2.SpaceID=b.SpaceID and EnvDataNoiseV2.ReportDate=b.ReportDate and EnvDataNoiseV2.id >b.ID);


ALTER TABLE `nccs`.`EnvDataNoiseV2` ADD UNIQUE INDEX `INDEX`(`ReportDate`, `SpaceID`) USING BTREE;



ALTER TABLE `nccs`.`EnvDataPm2dot5V2` DROP INDEX `INDEX`;

ALTER TABLE `nccs`.`EnvDataPm2dot5V2` MODIFY COLUMN `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '设备ID' AFTER `ReportDate`;

ALTER TABLE `nccs`.`EnvDataPm2dot5V2` ADD COLUMN `SpaceID` int(11) NOT NULL DEFAULT '0' AFTER `Val`;

UPDATE EnvDataPm2dot5V2 as e,SpaceAndDevice as sp SET e.SpaceID=sp.space_id WHERE e.DeviceID=sp.dev_id;
delete from EnvDataPm2dot5V2  where EnvDataPm2dot5V2.SpaceID=0;


DELETE EnvDataPm2dot5V2  FROM EnvDataPm2dot5V2  INNER JOIN (SELECT min(id) as ID,ReportDate,SpaceID  FROM EnvDataPm2dot5V2 GROUP BY ReportDate,SpaceID HAVING Count(1)>1) as b on (EnvDataPm2dot5V2.SpaceID=b.SpaceID and EnvDataPm2dot5V2.ReportDate=b.ReportDate and EnvDataPm2dot5V2.id >b.ID);


ALTER TABLE `nccs`.`EnvDataPm2dot5V2` ADD UNIQUE INDEX `INDEX`(`ReportDate`, `SpaceID`) USING BTREE;



ALTER TABLE `nccs`.`EnvDataRadarV2` DROP INDEX `INDEX`;

ALTER TABLE `nccs`.`EnvDataRadarV2` MODIFY COLUMN `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '设备ID' AFTER `ReportDate`;

ALTER TABLE `nccs`.`EnvDataRadarV2` ADD COLUMN `SpaceID` int(11) NOT NULL DEFAULT '0' AFTER `Val`;

UPDATE EnvDataRadarV2 as e,SpaceAndDevice as sp SET e.SpaceID=sp.space_id WHERE e.DeviceID=sp.dev_id;
delete from EnvDataRadarV2  where EnvDataRadarV2.SpaceID=0;

DELETE EnvDataRadarV2  FROM EnvDataRadarV2  INNER JOIN (SELECT min(id) as ID,ReportDate,SpaceID  FROM EnvDataRadarV2 GROUP BY ReportDate,SpaceID HAVING Count(1)>1) as b on (EnvDataRadarV2.SpaceID=b.SpaceID and EnvDataRadarV2.ReportDate=b.ReportDate and EnvDataRadarV2.id >b.ID);


ALTER TABLE `nccs`.`EnvDataRadarV2` ADD UNIQUE INDEX `INDEX`(`ReportDate`, `SpaceID`) USING BTREE;



ALTER TABLE `nccs`.`EnvDataTemperatureV2` DROP INDEX `INDEX`;

ALTER TABLE `nccs`.`EnvDataTemperatureV2` MODIFY COLUMN `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '设备ID' AFTER `ReportDate`;

ALTER TABLE `nccs`.`EnvDataTemperatureV2` ADD COLUMN `SpaceID` int(11) NOT NULL DEFAULT '0' AFTER `Val`;

UPDATE EnvDataTemperatureV2 as e,SpaceAndDevice as sp SET e.SpaceID=sp.space_id WHERE e.DeviceID=sp.dev_id;
delete from EnvDataTemperatureV2  where EnvDataTemperatureV2.SpaceID=0;

DELETE EnvDataTemperatureV2  FROM EnvDataTemperatureV2  INNER JOIN (SELECT min(id) as ID,ReportDate,SpaceID  FROM EnvDataTemperatureV2 GROUP BY ReportDate,SpaceID HAVING Count(1)>1) as b on (EnvDataTemperatureV2.SpaceID=b.SpaceID and EnvDataTemperatureV2.ReportDate=b.ReportDate and EnvDataTemperatureV2.id >b.ID);


ALTER TABLE `nccs`.`EnvDataTemperatureV2` ADD UNIQUE INDEX `INDEX`(`ReportDate`, `SpaceID`) USING BTREE;



ALTER TABLE `nccs`.`EnvDataTvocV2` DROP INDEX `INDEX`;

ALTER TABLE `nccs`.`EnvDataTvocV2` MODIFY COLUMN `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '设备ID' AFTER `ReportDate`;

ALTER TABLE `nccs`.`EnvDataTvocV2` ADD COLUMN `SpaceID` int(11) NOT NULL DEFAULT '0' AFTER `Val`;

UPDATE EnvDataTvocV2 as e,SpaceAndDevice as sp SET e.SpaceID=sp.space_id WHERE e.DeviceID=sp.dev_id;
delete from EnvDataTvocV2  where EnvDataTvocV2.SpaceID=0;

DELETE EnvDataTvocV2  FROM EnvDataTvocV2  INNER JOIN (SELECT min(id) as ID,ReportDate,SpaceID  FROM EnvDataTvocV2 GROUP BY ReportDate,SpaceID HAVING Count(1)>1) as b on (EnvDataTvocV2.SpaceID=b.SpaceID and EnvDataTvocV2.ReportDate=b.ReportDate and EnvDataTvocV2.id >b.ID);


ALTER TABLE `nccs`.`EnvDataTvocV2` ADD UNIQUE INDEX `INDEX`(`ReportDate`, `SpaceID`) USING BTREE;


update Space set  Space.location=Space.name;


CREATE TABLE `nccs`.`LogicClassAndPartitionNode`  (
      `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'ID',
      `class_id` int(11) NOT NULL COMMENT '逻辑分区ID',
      `node_id` int(11) NOT NULL DEFAULT 0,
      PRIMARY KEY (`id`) USING BTREE,
      UNIQUE INDEX `classDevIndex`(`class_id`, `node_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '逻辑分区设备' ROW_FORMAT = Dynamic;

insert into LogicClassAndPartitionNode(class_id, node_id) SELECT DISTINCT l.class_id,pn.id from LogicClassDevices l inner join SpaceAndDevice sd on l.device=sd.dev_id inner join PartitionNode pn on sd.space_id = pn.space_id inner join `Partition` p on (sd.space_id = pn.space_id  and p.is_deleted=0) on duplicate key update class_id=values(class_id),node_id=values(node_id);



drop table BrdModeMember;
drop table EnvControlDevices;
drop table GraphicSessionMember;
drop table LogicClassDevices;
drop table SessionDevice;
drop table UserDevices;

DROP PROCEDURE IF EXISTS Pro_Temp_ColumnWork;
DELIMITER $$
-- 1表示新增列,2表示修改列类型,3表示删除列
CREATE PROCEDURE Pro_Temp_ColumnWork(TableName VARCHAR(50),ColumnName VARCHAR(50),SqlStr VARCHAR(4000),CType INT)
BEGIN
    declare done int default false;
    declare temp_name varchar(64) default null;
    declare Rows1 int default 0;
    declare temp_sql varchar(4000) default null;
    declare cur cursor for select  TABLE_NAME  from information_schema.TABLES where TABLE_NAME like concat(TableName,'%');
    DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = TRUE;
    open cur;
    REPEAT
        FETCH cur into temp_name;
        if not done then
            SELECT COUNT(*) INTO Rows1  FROM INFORMATION_SCHEMA.Columns
            WHERE table_schema= 'nccs' AND table_name=temp_name AND column_name=ColumnName;
            -- 新增列
            IF (CType=1 AND Rows1<=0) THEN
                SET temp_sql := CONCAT( 'ALTER TABLE ',temp_name,' ADD COLUMN ',ColumnName,' ',SqlStr);
                -- 修改列类型
            ELSEIF (CType=2 AND Rows1>0)  THEN
                SET temp_sql := CONCAT('ALTER TABLE ',temp_name,' MODIFY  ',ColumnName,' ',SqlStr);
                -- 删除列
            ELSEIF (CType=3 AND Rows1>0) THEN
                SET temp_sql := CONCAT('ALTER TABLE  ',temp_name,' DROP COLUMN  ',ColumnName);
            ELSE  SET temp_sql :='';
            END IF;

            -- 执行命令
            IF (temp_sql<>'') THEN
                SET @SQL1 = temp_sql;
                PREPARE stmt1 FROM @SQL1;
                EXECUTE stmt1;
            END IF;

        end if;
    until done
        END REPEAT;

    close cur;

END$$

DELIMITER ;




CALL Pro_Temp_ColumnWork ('DevicePower','SchoolID','int(11) NOT NULL DEFAULT 0 AFTER `SubType`; ', 1);


DROP PROCEDURE IF EXISTS Pro_Temp_ColumnWork;

call sp_update_sub_table('DevicePower', 'INSERT INTO `nccs`.`?`(StatisticDay,DeviceID,SubID,SubType,PowerConsumed,UsedTime,SchoolID) SELECT StatisticDay,DeviceID,SubID,SubType,SUM(PowerConsumed) as  PowerConsumed,SUM(UsedTime) as UsedTime,-1 FROM `nccs`.`?`  GROUP BY StatisticDay,DeviceID,SubID,SubType on duplicate key update PowerConsumed=values(PowerConsumed),UsedTime=values(UsedTime)');
call sp_update_sub_table('DevicePower', 'DELETE FROM  `nccs`.`?`  WHERE  SchoolID!=-1');

call sp_update_sub_table('DevicePower', 'ALTER TABLE `nccs`.`?` DROP INDEX `StatisticDay`');

call sp_update_sub_table("DevicePower","ALTER TABLE `nccs`.`?` ADD COLUMN `SpaceID` int(11) NOT NULL DEFAULT 0 AFTER `SubType`");

call sp_update_sub_table("DevicePower","ALTER TABLE `nccs`.`?` ADD UNIQUE INDEX `StatisticDay`(`StatisticDay`, `DeviceID`, `SpaceID`, `SubID`, `SubType`) USING BTREE");

call sp_update_sub_table("DevicePower","UPDATE `nccs`.`?` as e,SpaceAndDevice as sp SET e.SpaceID=sp.space_id WHERE e.DeviceID=sp.dev_id");

call sp_update_sub_table('DevicePower', 'ALTER TABLE `nccs`.`?` DROP COLUMN `SchoolID`');
-- ClkMode表增加status字段

ALTER TABLE `nccs`.`CLKMode` ADD COLUMN `status` tinyint(2) NOT NULL DEFAULT 0 COMMENT '模式的状态' AFTER `receive_member_type`;

-- SectionTable删除name字段，增加section字段

ALTER TABLE `nccs`.`SectionTable` DROP INDEX `SectionTableUnique`;

ALTER TABLE `nccs`.`SectionTable` DROP INDEX `SectionTableIndex`;

ALTER TABLE `nccs`.`SectionTable` ADD COLUMN `section` int(11) NOT NULL COMMENT '节次num' AFTER `name`;

UPDATE `nccs`.`SectionTable` SET `section` =  CONVERT(`name`, UNSIGNED) WHERE `name` REGEXP '^[0-9]+$';

DELETE FROM `nccs`.`SectionTable`  WHERE `name` NOT REGEXP '^[0-9]+$';

ALTER TABLE `nccs`.`SectionTable` DROP COLUMN `name`;

ALTER TABLE `nccs`.`SectionTable` ADD UNIQUE INDEX `SectionTableUniqueNum`(`zone`, `section`) USING BTREE;

ALTER TABLE `nccs`.`SectionTable` ADD INDEX `SectionTableIndexNum`(`zone`, `section`) USING BTREE;

-- ----------------------------
-- Table structure for MediaFileExtend
-- ----------------------------
DROP TABLE IF EXISTS `MediaFileExtend`;
CREATE TABLE `MediaFileExtend` (
    `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '媒体文件的id',
    `path` varchar(255) CHARACTER SET utf8 NOT NULL DEFAULT '' COMMENT '文件对端的路径',
    `peer_id` int(11) NOT NULL DEFAULT '0' COMMENT '对端的媒体文件id',
    `peer` tinyint(4) NOT NULL DEFAULT '0' COMMENT '0:本地;1:汇聚平台;l2:云端',
    `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
    `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (`id`),
    UNIQUE KEY `unique_index` (`peer_id`,`peer`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=57 DEFAULT CHARSET=latin1;


-- ----------------------------
-- Table structure for PlaySessionExtend
-- ----------------------------
DROP TABLE IF EXISTS `PlaySessionExtend`;
CREATE TABLE `PlaySessionExtend` (
     `SessionID` int(11) NOT NULL,
     `PeerSessionID` int(11) NOT NULL COMMENT '对端的任务关联ID',
     `Peer` tinyint(4) NOT NULL COMMENT '0表示本地。1表示汇聚平台。2表示云端。3表示第三方OpenAPI',
     `Description` varchar(512) CHARACTER SET utf8 NOT NULL DEFAULT '' COMMENT '该任务的描述信息',
     `SyncValue` int(11) NOT NULL DEFAULT '0',
     `UpdateTime` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
     `CreateTime` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
     PRIMARY KEY (`SessionID`),
     UNIQUE KEY `peerSessoinUniqueIndex` (`PeerSessionID`,`Peer`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


ALTER TABLE `nccs`.`MediaFiles` ADD COLUMN `CreateSource` tinyint(4) NOT NULL DEFAULT '0' COMMENT '0表示本地。1表示汇聚平台。2表示云端。3表示第三方OpenAPI' AFTER `Check`;
ALTER TABLE `nccs`.`PlaySessions` ADD COLUMN `CreateSource` tinyint(4) NOT NULL DEFAULT '0' COMMENT '0表示本地。1表示汇聚平台。2表示云端。3表示第三方OpenAPI' AFTER `ReceivingEndType`;

-- ----------------------------
-- Timetable ADD COLUMN and change DevId to SpaceID
-- ----------------------------

ALTER TABLE `nccs`.`Timetable` DROP INDEX `only`;

ALTER TABLE `nccs`.`Timetable` DROP INDEX `deviceId_idx`;

ALTER TABLE `nccs`.`Timetable` DROP FOREIGN KEY `deviceIdKey`;

ALTER TABLE `nccs`.`Timetable` DROP FOREIGN KEY `userIdKey`;

ALTER TABLE `nccs`.`Timetable` ADD COLUMN `TermName` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT "" COMMENT '学年-学期。如：2023-2024-1' AFTER `Id`;

UPDATE `nccs`.`Timetable` SET `TermName` = (IFNULL((SELECT Description from `nccs`.`BaseInfo` where InfomationID = 285),''));

ALTER TABLE `nccs`.`Timetable` MODIFY COLUMN `WeekDay` tinyint(4) NOT NULL DEFAULT 0 COMMENT '上课星期' AFTER `TermName`;

ALTER TABLE `nccs`.`Timetable` ADD COLUMN `StartSection` int(11) NOT NULL DEFAULT 0 COMMENT '开始节次' AFTER `WeekDay`;

ALTER TABLE `nccs`.`Timetable` MODIFY COLUMN `Start` datetime(0) NOT NULL DEFAULT '9999-12-31 23:59:59' COMMENT '开始时间' AFTER `StartSection`;

UPDATE `nccs`.`Timetable` SET `StartSection` = (IFNULL((SELECT `section` from `nccs`.`SectionTable` where `start` = time(`nccs`.`Timetable`.`Start`) limit 1), 0));

ALTER TABLE `nccs`.`Timetable` ADD COLUMN `EndSection` int(11) NOT NULL DEFAULT 0 COMMENT '结束节次' AFTER `Start`;

ALTER TABLE `nccs`.`Timetable` MODIFY COLUMN `End` datetime(0) NOT NULL DEFAULT '0000-01-01 00:00:00' COMMENT '结束时间' AFTER `EndSection`;

UPDATE `nccs`.`Timetable` SET `EndSection` =  (IFNULL((SELECT `section` from `nccs`.`SectionTable` where `end` = time(`nccs`.`Timetable`.`End`) limit 1), 0));

ALTER TABLE `nccs`.`Timetable` ADD COLUMN `SpaceID` int(11) NOT NULL COMMENT '空间ID' AFTER `End`;

UPDATE `nccs`.`Timetable` SET `SpaceID` = (IFNULL((SELECT space_id from `nccs`.`SpaceAndDevice` where dev_id = `nccs`.`Timetable`.`DevId`), 0));

ALTER TABLE `nccs`.`Timetable` DROP COLUMN `DevId`;

ALTER TABLE `nccs`.`Timetable` DROP INDEX `table_idx`;

ALTER TABLE `nccs`.`Timetable` ADD COLUMN `ClassName` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT "" COMMENT '教室名称' AFTER `SpaceID`;

UPDATE `nccs`.`Timetable` SET `ClassName` = (IFNULL((SELECT `name` from `nccs`.`Space` where id = `nccs`.`Timetable`.`SpaceID`), ''));

ALTER TABLE `nccs`.`Timetable` MODIFY COLUMN `UserId` int(11) NOT NULL DEFAULT 0 COMMENT '老师在idste系统ID' AFTER `ClassName`;

ALTER TABLE `nccs`.`Timetable` ADD COLUMN `UserSn` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT "" COMMENT '老师工号' AFTER `UserId`;

UPDATE `nccs`.`Timetable` SET `UserSn` = (IFNULL((SELECT `User_Sn` from `nccs`.`Users` where `User_ID` = `nccs`.`Timetable`.`UserId`),""));

ALTER TABLE `nccs`.`Timetable` ADD COLUMN `UserName` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT "" COMMENT '老师姓名' AFTER `UserSn`;

UPDATE `nccs`.`Timetable` SET `UserName` = (IFNULL((SELECT `User_Desc` from `nccs`.`Users` where `User_ID` = `nccs`.`Timetable`.`UserId`), ''));

ALTER TABLE `nccs`.`Timetable` ADD COLUMN `CourseName` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT "" COMMENT '课程名称' AFTER `UserName`;

ALTER TABLE `nccs`.`Timetable` ADD UNIQUE INDEX `only`(`SpaceID`, `UserId`, `WeekDay`, `Start`, `End`, `Type`, `TermName`) USING BTREE;

ALTER TABLE `nccs`.`Timetable` ADD INDEX `deviceId_idx`(`SpaceID`) USING BTREE;

ALTER TABLE `nccs`.`Timetable` ADD INDEX `table_idx`(`SpaceID`, `UserId`) USING BTREE;

-- Timetable change end --


-- D08.03.05
-- 采播播放列表
CREATE TABLE IF NOT EXISTS `nccs`.`PlayerPlayList`  (
                                                        `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT,
                                                        `player_id` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备id',
                                                        `list_name` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '列表名称',
                                                        `files` varchar(20480) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '列表文件，json字符串',
                                                        `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
                                                        `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
                                                        PRIMARY KEY (`id`) USING BTREE,
                                                        UNIQUE INDEX `index`(`player_id`, `list_name`) USING BTREE COMMENT '联合索引'
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic COMMENT = '采播播放列表';

ALTER TABLE `nccs`.`Players` ADD COLUMN `SyncValue` int(11) NULL DEFAULT 0 COMMENT '播放列表同步字';

-- 删除采播默认的启用禁用场景
DELETE FROM `nccs`.`PlayerScenes` WHERE `PlayerID` LIKE '57%' AND ( `SceneID` = 0 OR `SceneID` = 1 );


-- D08.03.06
ALTER TABLE `nccs`.`OAuthUser` ADD COLUMN `ForPlat` int(11) NOT NULL DEFAULT 0 COMMENT '0:服务器用户1:设备端用户' AFTER `Info`;

ALTER TABLE `nccs`.`OAuthAppInfo` MODIFY COLUMN `IsAllPrivilege` bigint(1) NOT NULL DEFAULT 0 COMMENT '0:非全部，1：全部权限' AFTER `AppSecret`;

ALTER TABLE `nccs`.`OAuthAppInfo` ADD COLUMN `Id` INT AUTO_INCREMENT PRIMARY KEY FIRST;

ALTER TABLE `nccs`.`OAuthAppInfo` ADD COLUMN `SyncValue` int(11) NOT NULL DEFAULT 1 COMMENT '数据更新自动加1' AFTER `RedirectUrl`;

-- D08.03.07
-- 处理以前版本手动任务的模板和模式不为空的情况
update PlaySessions set Template = null, BrdMode = null where SessionType in(2, 9);


CREATE TABLE IF NOT EXISTS `nccs`.`CourseRecord`  (
                                                      `id` int(11) NOT NULL AUTO_INCREMENT,
                                                      `teacher_id` int(11) NOT NULL DEFAULT 0 COMMENT '教室ID',
                                                      `teacher_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '教师名称',
                                                      `course` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '课程信息',
                                                      `class_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '教室名称',
                                                      `space_id` int(11) NOT NULL DEFAULT '0' COMMENT '空间ID',
                                                      `record_user_id` int(11) NOT NULL DEFAULT 0 COMMENT '评价人ID',
                                                      `record_user_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '评价人名称',
                                                      `content` varchar(1000) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '评论内容',
                                                      `level` int(11) NOT NULL DEFAULT '0' COMMENT '星级',
                                                      `update_time` datetime(0) NOT NULL DEFAULT CURRENT_TIMESTAMP(0) ON UPDATE CURRENT_TIMESTAMP(0),
                                                      `create_time` datetime(0) NOT NULL DEFAULT CURRENT_TIMESTAMP(0),
                                                      PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '巡课评论表' ROW_FORMAT = Dynamic;

CREATE TABLE IF NOT EXISTS `nccs`.`CourseUser`  (
                                                    `id` int(11) NOT NULL AUTO_INCREMENT,
                                                    `user_id` int(11) NOT NULL COMMENT '巡课老师ID',
                                                    `course_user_id` int(11) NOT NULL COMMENT '被巡课老师ID',
                                                    `update_time` datetime(0) NOT NULL DEFAULT CURRENT_TIMESTAMP(0) ON UPDATE CURRENT_TIMESTAMP(0),
                                                    `create_time` datetime(0) NOT NULL DEFAULT CURRENT_TIMESTAMP(0),
                                                    PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

CREATE TABLE IF NOT EXISTS `nccs`.`CourseComment`  (
                                                       `id` int(11) NOT NULL AUTO_INCREMENT,
                                                       `name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
                                                       `content` varchar(1000) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
                                                       `update_time` datetime(0) NOT NULL DEFAULT CURRENT_TIMESTAMP(0) ON UPDATE CURRENT_TIMESTAMP(0),
                                                       `create_time` datetime(0) NOT NULL DEFAULT CURRENT_TIMESTAMP(0),
                                                       PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '自定义评论表' ROW_FORMAT = DYNAMIC;



ALTER TABLE `nccs`.`Space` ADD COLUMN `record_config` varchar(600) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '录播配置' AFTER `master_dev_id`;

ALTER TABLE `nccs`.`Monitor` ADD COLUMN `name` VARCHAR(255) NOT NULL DEFAULT '' AFTER `space_id`;

UPDATE Monitor m  INNER JOIN (SELECT MIN(id) as id ,space_id FROM Monitor GROUP BY space_id) as m1 on m1.space_id=m.space_id  SET m.`name`=IF(m1.id=m.id,'监控1','监控2');


-- D08.03.10
-- 修改索引
ALTER TABLE `nccs`.`SessionAndPartitionNode` DROP INDEX `session_id`;
ALTER TABLE `nccs`.`SessionAndPartitionNode` ADD UNIQUE `session_id`(`session_id`, `partition_id`, `key_index`) USING BTREE;
ALTER TABLE `nccs`.`DeviceList` DROP FOREIGN KEY `DevClass`;
ALTER TABLE `nccs`.`DeviceList` DROP INDEX `DevClass`;

ALTER TABLE `nccs`.`PlaySessionExtend` ADD COLUMN `AcceptTime` VARCHAR(20) NOT NULL DEFAULT '' AFTER `SyncValue`;

-- 用户静态二维码
ALTER TABLE `nccs`.`Users` ADD COLUMN `QrCode`  varchar(255) NOT NULL DEFAULT '' COMMENT '静态二维码' AFTER `MgrReceivingEndType`;

-- D08.03.11
ALTER TABLE `nccs`.`BaseInfo` MODIFY COLUMN `InfoValue` bigint(20);

-- D08.03.12
ALTER TABLE `nccs`.`MicPhoneList` ADD COLUMN `delete_time`  bigint NOT NULL DEFAULT 0 COMMENT '删除时间' AFTER `create_time`;
ALTER TABLE `nccs`.`MicStubList` ADD COLUMN `delete_time`  bigint NOT NULL DEFAULT 0 COMMENT '删除时间' AFTER `create_time`;

CREATE TABLE IF NOT EXISTS `nccs`.`TimeTablePowerLog` (
                                                          `ID` int(11) NOT NULL AUTO_INCREMENT,
                                                          `TimeTableID` int(11) NOT NULL DEFAULT '0' COMMENT '课表ID',
                                                          `WeekDay` tinyint(4) NOT NULL DEFAULT '0' COMMENT '上课星期',
                                                          `Start` varchar(255) NOT NULL DEFAULT '' COMMENT '开始时间',
                                                          `End` varchar(255) NOT NULL DEFAULT '' COMMENT '结束时间',
                                                          `SpaceID` int(11) NOT NULL DEFAULT '0' COMMENT '联动教室ID',
                                                          `SpaceName` varchar(255) NOT NULL DEFAULT '' COMMENT '联动教室名称',
                                                          `DeviceID` varchar(255) NOT NULL DEFAULT '' COMMENT '设备ID',
                                                          `AutoPower` int(11) NOT NULL DEFAULT '0' COMMENT '0-自动关机  1-自动开机',
                                                          `AutoTime` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '执行时间',
                                                          `SendCode` int(11) NOT NULL DEFAULT '0' COMMENT '联动开机下发结果',
                                                          `CheckTime` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '最后检测时间',
                                                          `CheckNum` int(11) NOT NULL DEFAULT '0' COMMENT '检测次数',
                                                          `CheckResult` varchar(255) NOT NULL DEFAULT '' COMMENT '检查结果',
                                                          `AddTime` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '日志生成时间',
                                                          PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='课表联动开关机日志';

-- 新增告警消息接收用户标识字段
ALTER TABLE `nccs`.`Users` ADD COLUMN `IsAlarmMsgReceiver` tinyint(1) NOT NULL DEFAULT 0 COMMENT '是否是告警消息接收用户，0-否，1-是' AFTER `QrCode`;

-- 迁移课表同步和数据库备份异常接收人到Users表
UPDATE `nccs`.`Users` SET `IsAlarmMsgReceiver` = 1 WHERE`User_ID` IN (SELECT `InfoValue` FROM `nccs`.`BaseInfo` WHERE `InfoValue` IS NOT NULL AND ( `InfomationID` = 292 OR `InfomationID` = 357 ));




-- RfChildType，物联二级分类改为逻辑删除 -以适应能耗统计报表数据
ALTER TABLE `nccs`.`RfChildType` ADD  COLUMN `IsDeleted` tinyint(1) NOT NULL DEFAULT 0;
ALTER TABLE `nccs`.`RfChildType` ADD  COLUMN `CreateTime` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP;
ALTER TABLE `nccs`.`RfChildType` ADD  COLUMN `UpdateTime` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP;
-- 能耗统计表增加物联二级分类字段。为数据统计做支撑
call sp_update_sub_table('DevicePower', 'ALTER TABLE `nccs`.`?` ADD  COLUMN `RfChildID` INT(11) NOT NULL DEFAULT 0;');
call sp_update_sub_table('DevicePower', 'UPDATE `nccs`.`?` d LEFT JOIN RfChildType child on (child.IsDefault=1 and child.IsDeleted=0 and child.RfType=d.SubType ) SET d.RfChildID=child.ID WHERE d.SubType<256 ;');

ALTER TABLE `nccs`.`DeviceList` ADD  COLUMN `CreateTime` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP;
UPDATE nccs.DeviceList d INNER JOIN (SELECT DeviceID,MIN(DateTime) as DateTime  FROM DeviceLog  GROUP BY DeviceID) m on m.DeviceID=d.DevID  SET d.CreateTime=m.DateTime;


UPDATE `nccs`.`EnvDataCh2oV2` SET `DeviceID`='' WHERE `DeviceID` is null;
ALTER TABLE `nccs`.`EnvDataCh2oV2` MODIFY COLUMN `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '设备ID' AFTER `ReportDate`;
ALTER TABLE `nccs`.`EnvDataCh2oV2` DROP INDEX `INDEX`;
ALTER TABLE `nccs`.`EnvDataCh2oV2` ADD UNIQUE INDEX `INDEX`(`ReportDate`, `SpaceID`, `DeviceID`) USING BTREE;


UPDATE `nccs`.`EnvDataCo2V2` SET `DeviceID`='' WHERE `DeviceID` is null;
ALTER TABLE `nccs`.`EnvDataCo2V2` MODIFY COLUMN `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '设备ID' AFTER `ReportDate`;
ALTER TABLE `nccs`.`EnvDataCo2V2` DROP INDEX `INDEX`;
ALTER TABLE `nccs`.`EnvDataCo2V2` ADD UNIQUE INDEX `INDEX`(`ReportDate`, `SpaceID`, `DeviceID`) USING BTREE;

UPDATE `nccs`.`EnvDataHumidityV2` SET `DeviceID`='' WHERE `DeviceID` is null;
ALTER TABLE `nccs`.`EnvDataHumidityV2` MODIFY COLUMN `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '设备ID' AFTER `ReportDate`;
ALTER TABLE `nccs`.`EnvDataHumidityV2` DROP INDEX `INDEX`;
ALTER TABLE `nccs`.`EnvDataHumidityV2` ADD UNIQUE INDEX `INDEX`(`ReportDate`, `SpaceID`, `DeviceID`) USING BTREE;


UPDATE `nccs`.`EnvDataLightV2` SET `DeviceID`='' WHERE `DeviceID` is null;
ALTER TABLE `nccs`.`EnvDataLightV2` MODIFY COLUMN `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '设备ID' AFTER `ReportDate`;
ALTER TABLE `nccs`.`EnvDataLightV2` DROP INDEX `INDEX`;
ALTER TABLE `nccs`.`EnvDataLightV2` ADD UNIQUE INDEX `INDEX`(`ReportDate`, `SpaceID`, `DeviceID`) USING BTREE;


UPDATE `nccs`.`EnvDataNoiseV2` SET `DeviceID`='' WHERE `DeviceID` is null;
ALTER TABLE `nccs`.`EnvDataNoiseV2` MODIFY COLUMN `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '设备ID' AFTER `ReportDate`;
ALTER TABLE `nccs`.`EnvDataNoiseV2` DROP INDEX `INDEX`;
ALTER TABLE `nccs`.`EnvDataNoiseV2` ADD UNIQUE INDEX `INDEX`(`ReportDate`, `SpaceID`, `DeviceID`) USING BTREE;


UPDATE `nccs`.`EnvDataPm2dot5V2` SET `DeviceID`='' WHERE `DeviceID` is null;
ALTER TABLE `nccs`.`EnvDataPm2dot5V2` MODIFY COLUMN `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '设备ID' AFTER `ReportDate`;
ALTER TABLE `nccs`.`EnvDataPm2dot5V2` DROP INDEX `INDEX`;
ALTER TABLE `nccs`.`EnvDataPm2dot5V2` ADD UNIQUE INDEX `INDEX`(`ReportDate`, `SpaceID`, `DeviceID`) USING BTREE;



UPDATE `nccs`.`EnvDataTemperatureV2` SET `DeviceID`='' WHERE `DeviceID` is null;
ALTER TABLE `nccs`.`EnvDataTemperatureV2` MODIFY COLUMN `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '设备ID' AFTER `ReportDate`;
ALTER TABLE `nccs`.`EnvDataTemperatureV2` DROP INDEX `INDEX`;
ALTER TABLE `nccs`.`EnvDataTemperatureV2` ADD UNIQUE INDEX `INDEX`(`ReportDate`, `SpaceID`, `DeviceID`) USING BTREE;

UPDATE `nccs`.`EnvDataTvocV2` SET `DeviceID`='' WHERE `DeviceID` is null;
ALTER TABLE `nccs`.`EnvDataTvocV2` MODIFY COLUMN `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '设备ID' AFTER `ReportDate`;
ALTER TABLE `nccs`.`EnvDataTvocV2` DROP INDEX `INDEX`;
ALTER TABLE `nccs`.`EnvDataTvocV2` ADD UNIQUE INDEX `INDEX`(`ReportDate`, `SpaceID`, `DeviceID`) USING BTREE;

ALTER TABLE `nccs`.`ReportData` ADD  COLUMN `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP;
ALTER TABLE `nccs`.`ReportData` ADD  COLUMN `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP;

ALTER TABLE `nccs`.`MicPhoneList` ADD  COLUMN `used_time` INT(11) NOT NULL DEFAULT 0;


CREATE TABLE IF NOT EXISTS `nccs`.`DeviceSubStatus` (
                                                        `id` int(11) NOT NULL AUTO_INCREMENT,
                                                        `dev_id` varchar(255) NOT NULL COMMENT '设备ID',
                                                        `space_id` int(11) NOT NULL DEFAULT '0' COMMENT '空间ID',
                                                        `sub_id` int(11) NOT NULL COMMENT '0-31 表示物联。 256,257,258 表示中控、投影、二路投影',
                                                        `rf_child_type` int(11) NOT NULL DEFAULT '0' COMMENT '物联二级分类',
                                                        `status` int(11) NOT NULL COMMENT '状态、-1 表示离线。其余状态由不同的类型决定字段含义',
                                                        `user_id` int(11) NOT NULL DEFAULT '0' COMMENT '操作用户ID',
                                                        `update_status_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '状态更新时间',
                                                        `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
                                                        PRIMARY KEY (`id`),
                                                        KEY `index` (`dev_id`,`space_id`,`sub_id`,`rf_child_type`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='设备、以及子设备 状态更新存储表';

CREATE TABLE IF NOT EXISTS `nccs`.`DeviceUsedTime` (
                                                       `ID` int(11) NOT NULL AUTO_INCREMENT,
                                                       `DeviceID` varchar(255) NOT NULL COMMENT '设备ID',
                                                       `StatisticDay` date NOT NULL COMMENT '日期',
                                                       `SubID` int(11) NOT NULL COMMENT '0-31 表示物联 256-257-258-259-260 表示中控、投影、二路投影、设备故障、用户上报故障开关机、261 表示设备离线情况统计',
                                                       `StartTime` datetime NOT NULL COMMENT '开始时间',
                                                       `EndTime` datetime NOT NULL COMMENT '结束时间',
                                                       `UsedTime` int(11) NOT NULL COMMENT '单位s',
                                                       `SpaceID` int(11) NOT NULL DEFAULT '0',
                                                       `RfChildID` int(11) NOT NULL DEFAULT '0',
                                                       `UserID` int(11) NOT NULL DEFAULT '0' COMMENT '使用人',
                                                       PRIMARY KEY (`ID`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='设备使用时长统计表';

CREATE TABLE IF NOT EXISTS `nccs`.`PrivilegeTemplate`  (
                                                           `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT COMMENT '用户权限模板id',
                                                           `name` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '模板名称',
                                                           `privilege_list` varchar(4096) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '权限列表，权限之间用逗号分割',
                                                           `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',
                                                           `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
                                                           PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '用户权限模板' ROW_FORMAT = Dynamic;

ALTER TABLE `nccs`.`ReportData` MODIFY COLUMN `header_column_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '子项关联ID' AFTER `row_id`;

-- function column_exists:
DROP FUNCTION IF EXISTS column_exists;
DELIMITER $$
CREATE FUNCTION column_exists(
    tname VARCHAR(64),
    cname VARCHAR(64)
)
    RETURNS BOOLEAN
    READS SQL DATA
BEGIN
    RETURN 0 < (SELECT COUNT(*)
                FROM `INFORMATION_SCHEMA`.`COLUMNS`
                WHERE `TABLE_SCHEMA` = SCHEMA()
                  AND `TABLE_NAME` = tname
                  AND `COLUMN_NAME` = cname);
END $$
DELIMITER ;

-- function drop_column_if_exists:
DROP PROCEDURE IF EXISTS drop_column_if_exists;

DELIMITER $$
CREATE PROCEDURE drop_column_if_exists(
    tname VARCHAR(64),
    cname VARCHAR(64)
)
BEGIN
    IF column_exists(tname, cname)
    THEN
        SET @drop_column_if_exists = CONCAT('ALTER TABLE `', tname, '` DROP COLUMN `', cname, '`');
        PREPARE drop_query FROM @drop_column_if_exists;
        EXECUTE drop_query;
    END IF;
END $$
DELIMITER ;

-- call drop_column_if_exists
CALL drop_column_if_exists('Student', 'SchoolID');
CALL drop_column_if_exists('RegisterUser', 'SchoolName');
CALL drop_column_if_exists('DeviceReserveHistory', 'SchoolID');
CALL drop_column_if_exists('DeviceReserveHistory', 'SchoolName');
CALL drop_column_if_exists('DeviceReserveHistory', 'MatchSchoolID');
CALL drop_column_if_exists('DeviceReserveHistory', 'MatchSchoolName');
CALL drop_column_if_exists('DeviceReserve', 'SchoolID');
CALL drop_column_if_exists('DeviceReserve', 'SchoolName');
CALL drop_column_if_exists('DeviceReserve', 'MatchSchoolID');
CALL drop_column_if_exists('DeviceReserve', 'MatchSchoolName');
CALL drop_column_if_exists('DevicePower', 'SchoolID');
CALL drop_column_if_exists('DevicePower2021', 'SchoolID');
CALL drop_column_if_exists('DevicePower2022', 'SchoolID');
CALL drop_column_if_exists('DevicePower2023', 'SchoolID');
CALL drop_column_if_exists('Scene', 'SchoolID');
CALL drop_column_if_exists('PwrDisplaySet', 'SchoolID');

-- drop created function
DROP PROCEDURE IF EXISTS drop_column_if_exists;
DROP FUNCTION IF EXISTS column_exists;


-- D08.03.13
update PlaySessionTime set Length = 0 where Length is null;
update PlaySessionTime set TempFlag = 0 where TempFlag is null;

ALTER TABLE `nccs`.`PlaySessionTime` MODIFY COLUMN `TempFlag` tinyint NOT NULL DEFAULT 0 AFTER `PlayTime`;

ALTER TABLE `nccs`.`PlaySessionTime` MODIFY COLUMN `Length` int NOT NULL DEFAULT 0 AFTER `TempFlag`;

CREATE TABLE IF NOT EXISTS `nccs`.`EnvDataPm10V2`  (
                                                       `id` int(10) NOT NULL AUTO_INCREMENT,
                                                       `ReportDate` datetime NOT NULL,
                                                       `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '设备ID',
                                                       `Val` float(11, 2) NOT NULL,
                                                       `SpaceID` int(11) NOT NULL DEFAULT 0,
                                                       PRIMARY KEY (`id`) USING BTREE,
                                                       UNIQUE INDEX `INDEX`(`ReportDate`, `SpaceID`, `DeviceID`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- -----------------------------------------------------
-- Table structure for Events
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`Events`  (
                                                `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT COMMENT '事件id',
                                                `name` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '事件名称',
                                                `event_type` tinyint(4) UNSIGNED NOT NULL DEFAULT 0 COMMENT '事件类型：0-无效，1-环境检测事件，2-GPIO事件，3-IOT事件，4-中控事件，5-状态检测事件',
                                                `duration` int(11) UNSIGNED NOT NULL DEFAULT 0 COMMENT '事件持续时间，单位：秒',
                                                `event_class` tinyint(4) UNSIGNED NOT NULL COMMENT '事件分类，1-设备特有事件，2-公共事件',
                                                `config` varchar(2048) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '公共事件配置，当even_classt为2时此项有效',
                                                `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
                                                `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
                                                PRIMARY KEY (`id`) USING BTREE,
                                                UNIQUE INDEX `name`(`name`) USING BTREE COMMENT '名称索引'
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '事件表' ROW_FORMAT = DYNAMIC;

-- -----------------------------------------------------
-- Table structure for DeviceAndEvent
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`DeviceAndEvent`  (
                                                        `dev_id` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备id',
                                                        `event_id` int(11) UNSIGNED NOT NULL COMMENT '事件id',
                                                        `logic` tinyint(4) UNSIGNED NOT NULL DEFAULT 1 COMMENT '逻辑关系，0-逻辑或，1-逻辑与',
                                                        `triggers` varchar(2048) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '事件触发条件，json字符串',
                                                        `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
                                                        `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
                                                        UNIQUE INDEX `index`(`dev_id`, `event_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '事件和设备绑定表' ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for StrategyInfo
-- ----------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`StrategyInfo`  (
                                                      `ID` int(10) NOT NULL AUTO_INCREMENT,
                                                      `Name` varchar(1024) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '策略的名称',
                                                      `StartDateTime` datetime NOT NULL COMMENT '策略开始运行时间。Y-m-d H:m:s格式',
                                                      `EndDateTime` datetime NOT NULL COMMENT '策略运行结束时间。Y-m-d H:m:s格式',
                                                      `Weekday` int(10) NOT NULL COMMENT '表示周几。bit1-bit6表示周一到周六，bit0表示周天',
                                                      `Times` varchar(1024) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '每天需要执行按事件执行具体操作的时间范围',
                                                      `Operation` varchar(2048) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '{}' COMMENT '该策略需要执行的操作。json格式',
                                                      `ReceivingEndType` int(10) NOT NULL DEFAULT 1 COMMENT '0: 设备 1：空间，2：分组',
                                                      `Status` tinyint(1) NOT NULL COMMENT '策略运行状态',
                                                      `StartEntryID` int(10) NOT NULL DEFAULT 0,
                                                      `EndEntryID` int(10) NOT NULL DEFAULT 0,
                                                      `UpdateTime` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
                                                      PRIMARY KEY (`ID`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for StrategyInfoAndPartitionNode
-- ----------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`StrategyInfoAndPartitionNode`  (
                                                                      `id` int(11) NOT NULL AUTO_INCREMENT,
                                                                      `strategy_id` int(10) NOT NULL COMMENT '环境策略ID',
                                                                      `partition_id` int(11) NOT NULL COMMENT '逻辑分区ID',
                                                                      PRIMARY KEY (`id`) USING BTREE,
                                                                      UNIQUE INDEX `logical_partition_id`(`partition_id`, `strategy_id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '模式接收成员空间表' ROW_FORMAT = DYNAMIC;

insert into nccs.StrategyInfoAndPartitionNode(strategy_id, partition_id) SELECT env_ctrl_info_id, partition_id from nccs.EnvControlAndPartitionNode;

drop table nccs.EnvControlAndPartitionNode;

-- ----------------------------
-- Table structure for StrategyAndEvent
-- ----------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`StrategyAndEvent`  (
                                                          `id` int(10) NOT NULL AUTO_INCREMENT,
                                                          `strategy_id` int(10) NOT NULL COMMENT '策略id',
                                                          `event_id` int(11) UNSIGNED NOT NULL COMMENT '事件id',
                                                          PRIMARY KEY (`id`) USING BTREE,
                                                          UNIQUE INDEX `strategy_event`(`strategy_id`, `event_id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = DYNAMIC;


UPDATE `nccs`.`Users` SET `Mgr_Privilege` = 1, `Dev_Privilege` = 1 WHERE `IsSuper` = 1;


-- D08.03.14
UPDATE  BaseInfo INNER JOIN (SELECT GROUP_CONCAT(ID separator ',') as id  FROM RfChildType WHERE IsDeleted=0) as r on 1=1 SET Description=CONCAT('{"power":{"enable":true,"index":0},"power_top":{"enable":true,"index":1},"used_time_top":{"enable":true,"index":2},"class":{"enable":true,"index":3},"rf":{"enable":true,"index":4,"list":[',r.id,']},"class_use":{"enable":true,"index":5},"task":{"enable":true,"index":6},"dynamic":{"enable":true,"index":7},"class_auth":{"enable":true,"index":8},"dev_used":{"enable":false,"index":0,"cfg":',Description,'},"user_used_time":{"enable":false,"index":0}}') WHERE InfomationID=407;


-- D08.03.15
CREATE TABLE IF NOT EXISTS `nccs`.`DeviceTotalEnergy`  (
                                                           `dev_id` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备id',
                                                           `statistic_datetime` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '统计的日期时间，按天：\"2023-06-30\" 按小时：\"2023-06-30 10\"',
                                                           `dev_energy` int(11) UNSIGNED NOT NULL DEFAULT 0 COMMENT '设备能耗，单位wh，总能耗=设备能耗+子设备能耗',
                                                           `sub_energy` int(11) UNSIGNED NOT NULL DEFAULT 0 COMMENT '所有子设备的能耗和，单位wh，总能耗=设备能耗+子设备能耗',
                                                           `dev_used_time` int(11) UNSIGNED NOT NULL DEFAULT 0 COMMENT '设备使用(开机)时长，单位s，总时长=设备开机时长+子设备开机时长',
                                                           `sub_used_time` int(11) UNSIGNED NOT NULL DEFAULT 0 COMMENT '所有子设备的开机时长之和，单位s，总时长=设备开机时长+子设备开机时长',
                                                           `statistic_type` tinyint(4) NOT NULL COMMENT '统计类型，0-按天，1-按小时',
                                                           `reported` tinyint(4) NOT NULL DEFAULT 0 COMMENT '该条数据是否已上报过，0-未上报，1-已向云平台上报',
                                                           `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',
                                                           `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
                                                           UNIQUE INDEX `index`(`dev_id`, `statistic_datetime`) USING BTREE COMMENT '设备id和统计日期索引'
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '设备总能耗统计表' ROW_FORMAT = Dynamic;


ALTER TABLE `nccs`.`Users` MODIFY COLUMN `User_Name` varchar(255) DEFAULT NULL collate utf8_bin COMMENT '用户登录名';
ALTER TABLE `nccs`.`Users` MODIFY COLUMN `User_Sn` varchar(255) DEFAULT NULL collate utf8_bin;
ALTER TABLE `nccs`.`Users` DROP INDEX `UsbKey_UNIQUE`;
ALTER TABLE `nccs`.`Users` DROP INDEX `UnionId_uni`;

UPDATE `nccs`.`Users` SET `Mgr_Privilege` = 1, `Dev_Privilege` = 1 WHERE `User_Name` = 'idste';



-- D08.03.16
ALTER TABLE `nccs`.`RfChildType` DROP INDEX `rfName`;

-- D08.03.17
call sp_update_sub_table('DevicePower', 'DELETE FROM `nccs`.`?` WHERE PowerConsumed=0 AND UsedTime=0;');

INSERT INTO `nccs`.`BaseInfo`(InfomationID, Description, InfoValue) (SELECT 286, 'EnableAutoPwrOffCtrl', InfoValue from `nccs`.`BaseInfo` where InfomationID = 281) ON DUPLICATE KEY UPDATE InfoValue = VALUES(InfoValue);

-- 全新安装和升级安装数据表差异处理
ALTER TABLE `nccs`.`BroadcastMode` MODIFY COLUMN `ReceivingEndType` int(11) NOT NULL DEFAULT 1 COMMENT '0:设备，1：空间 ，2：分组' AFTER `StopEntryID`;

ALTER TABLE `nccs`.`EnvDataInfraredV2` DROP INDEX `INDEX`;
ALTER TABLE `nccs`.`EnvDataInfraredV2` MODIFY COLUMN `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '设备ID' AFTER `ReportDate`;
ALTER TABLE `nccs`.`EnvDataInfraredV2` ADD UNIQUE INDEX `INDEX`(`ReportDate`, `SpaceID`, `DeviceID`) USING BTREE;

ALTER TABLE `nccs`.`EnvDataRadarV2` DROP INDEX `INDEX`;
ALTER TABLE `nccs`.`EnvDataRadarV2` MODIFY COLUMN `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '设备ID' AFTER `ReportDate`;
ALTER TABLE `nccs`.`EnvDataRadarV2` ADD UNIQUE INDEX `INDEX`(`ReportDate`, `SpaceID`, `DeviceID`) USING BTREE;

ALTER TABLE `nccs`.`Event` MODIFY COLUMN `Config` varbinary(64) NOT NULL COMMENT '事件配置' AFTER `EndTask`;
ALTER TABLE `nccs`.`Event` MODIFY COLUMN `Model` int(11) NOT NULL COMMENT '型号' AFTER `Config`;
ALTER TABLE `nccs`.`Event` MODIFY COLUMN `Version` int(11) NOT NULL DEFAULT 0 COMMENT '版本号:自动生成，前端禁止操作' AFTER `Model`;

ALTER TABLE `nccs`.`MediaFileExtend` MODIFY COLUMN `peer` tinyint(4) NOT NULL DEFAULT 0 COMMENT '0:本地;1:汇聚平台;2:云端' AFTER `peer_id`;

ALTER TABLE `nccs`.`PlayerScenes` COMMENT = '采播场景';

DROP PROCEDURE IF EXISTS PwrDisplaySet_key_proc;
DELIMITER $$
CREATE PROCEDURE PwrDisplaySet_key_proc()
BEGIN
    IF((SELECT COUNT(*) FROM INFORMATION_SCHEMA.STATISTICS WHERE TABLE_NAME = 'PwrDisplaySet' AND TABLE_SCHEMA = 'nccs' AND INDEX_NAME = 'uniqueIndex') > 0)
    THEN
        ALTER TABLE `nccs`.`PwrDisplaySet` DROP INDEX `uniqueIndex`;
    END IF;
    IF((SELECT COUNT(*) FROM INFORMATION_SCHEMA.STATISTICS WHERE TABLE_NAME = 'PwrDisplaySet' AND TABLE_SCHEMA = 'nccs' AND INDEX_NAME = 'PRIMARY') = 0)
    THEN
        ALTER TABLE `nccs`.`PwrDisplaySet` ADD PRIMARY KEY (`PwrID`) USING BTREE;
    END IF;
END $$
DELIMITER ;
CALL PwrDisplaySet_key_proc;
DROP PROCEDURE IF EXISTS PwrDisplaySet_key_proc;

ALTER TABLE `nccs`.`RfChildType` MODIFY COLUMN `IsDeleted` tinyint(1) NOT NULL DEFAULT 0 AFTER `UpdateTime`;

DROP PROCEDURE IF EXISTS section_table_id_proc;
DELIMITER $$
CREATE PROCEDURE section_table_id_proc()
BEGIN
    IF((SELECT COUNT(*) FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA='nccs' AND TABLE_NAME='SectionTable' AND COLUMN_NAME='id') = 0)
    THEN
        ALTER TABLE `nccs`.`SectionTable` ADD COLUMN `id` int(11) UNSIGNED NOT NULL FIRST;
        ALTER TABLE `nccs`.`SectionTable` ADD PRIMARY KEY (`id`) USING BTREE;
        ALTER TABLE `nccs`.`SectionTable` MODIFY COLUMN `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
    END IF;
END $$
DELIMITER ;
CALL section_table_id_proc;
DROP PROCEDURE IF EXISTS section_table_id_proc;

ALTER TABLE `nccs`.`Space` MODIFY COLUMN `name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '课表对接名称' AFTER `location`;
ALTER TABLE `nccs`.`Space` MODIFY COLUMN `space_type` int(11) NOT NULL DEFAULT 0 COMMENT '空间类型' AFTER `name`;
ALTER TABLE `nccs`.`Space` MODIFY COLUMN `class_type` int(11) NOT NULL DEFAULT 0 COMMENT '教室类型' AFTER `space_type`;

ALTER TABLE `nccs`.`Users` MODIFY COLUMN `User_Desc` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '用户姓名' AFTER `User_Name`;
ALTER TABLE `nccs`.`Users` MODIFY COLUMN `User_Sn` varchar(20) CHARACTER SET utf8 COLLATE utf8_bin NULL DEFAULT NULL COMMENT '学号或工号' AFTER `User_Type`;

DROP TABLE IF EXISTS `nccs`.`DevUsedStatus`;
DROP TABLE IF EXISTS `nccs`.`EnvDataCh2o`;
DROP TABLE IF EXISTS `nccs`.`EnvDataCo2`;
DROP TABLE IF EXISTS `nccs`.`EnvDataHumidity`;
DROP TABLE IF EXISTS `nccs`.`EnvDataInfrared`;
DROP TABLE IF EXISTS `nccs`.`EnvDataLight`;
DROP TABLE IF EXISTS `nccs`.`EnvDataNoise`;
DROP TABLE IF EXISTS `nccs`.`EnvDataPm2dot5`;
DROP TABLE IF EXISTS `nccs`.`EnvDataRadar`;
DROP TABLE IF EXISTS `nccs`.`EnvDataTemperature`;
DROP TABLE IF EXISTS `nccs`.`EnvDataTvoc`;


-- D08.03.21

ALTER TABLE `nccs`.`StrategyInfo` MODIFY COLUMN `Operation` varchar(8092) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL DEFAULT '{}' COMMENT '该策略需要执行的操作。json格式' AFTER `Times`;


-- D08.03.26
CREATE TABLE IF NOT EXISTS `nccs`.`ThirdClassQRCode`  (
                                                          `dev_id` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备id',
                                                          `app_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT 'OpenAPI app id',
                                                          `qrcode` varchar(512) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '第三方二维码',
                                                          UNIQUE INDEX `index`(`dev_id`, `app_id`) USING BTREE COMMENT '设备id和app_id联合索引'
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '第三方教室二维码' ROW_FORMAT = Dynamic;

-- 数据迁移
INSERT IGNORE INTO `nccs`.`ThirdClassQRCode` ( `dev_id`, `app_id`, `qrcode` ) ( SELECT `dev_id`, `app_id`, `qrcode` FROM `nccs`.`ThirdClassDevices` WHERE `qrcode` <> '' );
-- 删除未绑定教室的记录
DELETE FROM `nccs`.`ThirdClassDevices` WHERE `third_class_id` IS NULL;
-- 删除qrcode字段
ALTER TABLE `nccs`.`ThirdClassDevices` DROP COLUMN `qrcode`;



SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;